/* Worker Config
   von Ralf Hoffmann
   Version 1.3 */

#include "AGUI-X.h"
#include "COMS.h"
#include "CONFIG.h"
#include "wconfig.h"
#include "lowlevelfunc.h"
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>

extern int errno;
extern struct _globalgui _GlobalGUI;
extern char *_locale[];
extern char *_localecoms[];
extern char *_localeflags[];
extern char *_localeuflags[];
extern char _UFlags[][5];
extern int flaginfo[][2];
extern char *home;
extern int ColCnt;
extern unsigned long ColBuf[256];
extern int _NBH;
extern int _BBH;
extern struct _wconfig _WConfig;
struct _wconfig LConfig;

char *WCSelectLang()
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _ListView *langlv;
  _ListViewContent *last,*select,*report;
  _Button *tbutton;
  char *newlang=NULL,*catdir,*tstr;
  int end=FALSE,x;
  struct dirent *namelist;
  DIR *dir;
  int w,h,okw,cw,tw;
  
  h=150+10+10+10+_BBH;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  w=cw+okw;
  w+=10+20;
  tw=_CharWidth*17+15+30;
  if(tw>w) w=tw;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[9],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    langlv=_CreateListView(gfxwin,10,10,w-20,150,TRUE,FALSE,10,TRUE,FALSE,10,NULL,1);
    _CreateButton(gfxwin,10,170,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",2);
    _CreateButton(gfxwin,w-10-cw,170,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",3);
    x=1;
    last=_AddListViewContent(langlv,NULL,"english (builtin)",x++);
    last->fg_select=_black;
    last->bg_select=0;
    last->fg_active=_white;
    last->bg_active=_black;
    last->fg_sel_act=_white;
    last->bg_sel_act=_black;
    last->active=TRUE;
    select=last;
    catdir=(char*)_allocsafe(strlen(home)+1+9);
    strcpy(catdir,home);
    strcat(catdir,"/catalogs");
    dir=opendir(catdir);
    if(dir!=NULL) {
      while((namelist=readdir(dir))!=NULL) {
        if(strlen(namelist->d_name)>8) {
          if(strcmp(".catalog",(namelist->d_name)+strlen(namelist->d_name)-8)==0) {
          /* Dies ist ein Katalog */
            tstr=namelist->d_name;
            tstr[strlen(tstr)-8]=0;
            last=_AddListViewContent(langlv,last,namelist->d_name,x++);
            last->fg_select=_black;
            last->bg_select=0;
            last->fg_active=_white;
            last->bg_active=_black;
            last->fg_sel_act=_white;
            last->bg_sel_act=_black;
          }
        }      
      }
    }
    _freesafe(catdir);
    _RedrawWin(gfxwin);
    do {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if((msg->gadgettype==BUTTON_GADGET)&&(msg->type==ButtonRelease)) {
          tbutton=(_Button*)msg->gadget;
          switch(tbutton->data) {
            case 2:newlang=(char*)_allocsafe(strlen(select->text)+10);
                   strcpy(newlang,select->text);
                   end=TRUE;
                   break;
            case 3:end=TRUE;
                   break;
          }
        } else if(msg->gadgettype==LISTVIEW_GADGET) {
          report=msg->lv_oneselect;
          if(report!=NULL) {
            select->active=FALSE;
            report->active=TRUE;
            select=report;
            _RedrawWin(gfxwin);
          }
        } else if(msg->gadgettype==CLOSE_GADGET) {
          end=TRUE;
        }
        _ReplyMessage(msg);
      }
    } while(end==FALSE);
    _CloseWindow(gfxwin);
  }
  return newlang;
}

void WCSetLister(bool *tlefthbar_top,bool *tleftvbar_left,int *tlefthbar_height,int *tleftvbar_width,bool *trighthbar_top,bool *trightvbar_left,int *trighthbar_height,int *trightvbar_width)
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _ChooseButton *tchoosebutton,*tlefttop,*tleftleft,*trighttop,*trightleft;
  _StringGadget *report,*leftwidthsg,*leftheightsg,*rightwidthsg,*rightheightsg;
  _ListView *leftlv,*rightlv;
  int end,q;
  char *left_hbarheightstr,*left_vbarwidthstr,*right_hbarheightstr,*right_vbarwidthstr;
  int w,h,okw,cw,tw,ty;
  
  left_hbarheightstr=(char*)_allocsafe(3);
  left_vbarwidthstr=(char*)_allocsafe(3);
  right_hbarheightstr=(char*)_allocsafe(3);
  right_vbarwidthstr=(char*)_allocsafe(3);
  sprintf(left_hbarheightstr,"%d",*tlefthbar_height);
  sprintf(left_vbarwidthstr,"%d",*tleftvbar_width);
  sprintf(right_hbarheightstr,"%d",*trighthbar_height);
  sprintf(right_vbarwidthstr,"%d",*trightvbar_width);

  h=150+10+10+10+_BBH;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  w=TextWidth(_locale[19],strlen(_locale[19]))+10+5+10+TextWidth(_locale[20],strlen(_locale[20]));
  tw=2*TextWidth(_locale[21],strlen(_locale[21]))+15+15+15;
  if(tw>w) w=tw;
  tw=2*TextWidth(_locale[24],strlen(_locale[24]))+15+15+15;
  if(tw>w) w=tw;
  h=3+_CharHeight+3+5+5*_BBH+5;
  h+=_BBH;
  h+=_BBH+5;
  h+=_NBH+6;
  h+=5;
  h+=_BBH;
  h+=_BBH+5;
  h+=_NBH+6;
  h+=5;
  h+=5+10+_BBH;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[16],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,3+_GlobalGUI.font->ascent,1,_locale[19]);
    _CreateText(gfxwin,w/2+3,3+_GlobalGUI.font->ascent,1,_locale[20]);
    _CreateBevelBox(gfxwin,10,3+_CharHeight+3,w/2-2-10,h-3-_CharHeight-3-_BBH-15,HIGH);
    _CreateBevelBox(gfxwin,w/2+3,3+_CharHeight+3,w/2-2-10,h-3-_CharHeight-3-_BBH-15,HIGH);
    leftlv=_CreateListView(gfxwin,15,3+_CharHeight+3+5,w/2-2-20,5*_BBH,TRUE,*tlefthbar_top,*tlefthbar_height,TRUE,*tleftvbar_left,*tleftvbar_width,NULL,1);
    rightlv=_CreateListView(gfxwin,w/2+3+5,3+_CharHeight+3+5,w/2-2-20,5*_BBH,TRUE,*trighthbar_top,*trighthbar_height,TRUE,*trightvbar_left,*trightvbar_width,NULL,2);
    ty=3+_CharHeight+3+5+5*_BBH+5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[21]);
    _CreateText(gfxwin,w/2+3+5,ty+_GlobalGUI.font->ascent,1,_locale[21]);
    ty+=_BBH;
    _CreateText(gfxwin,35,ty+_GlobalGUI.font->ascent,1,_locale[22]);
    _CreateText(gfxwin,w/2+3+25,ty+_GlobalGUI.font->ascent,1,_locale[22]);
    tlefttop=_CreateChooseButton(gfxwin,35+(strlen(_locale[22])+1)*_CharWidth,ty,20,20,*tlefthbar_top,5);
    trighttop=_CreateChooseButton(gfxwin,w/2+3+25+(strlen(_locale[22])+1)*_CharWidth,ty,20,20,*trighthbar_top,7);
    ty+=_BBH+5;
    _CreateText(gfxwin,35,ty+_GlobalGUI.font->ascent,1,_locale[23]);
    _CreateText(gfxwin,w/2+3+25,ty+_GlobalGUI.font->ascent,1,_locale[23]);
    leftheightsg=_CreateStringGadget(gfxwin,35+(strlen(_locale[23])+1)*_CharWidth,ty,_CharWidth*4,_NBH+6,left_hbarheightstr,2,1,0,1,7,9);
    rightheightsg=_CreateStringGadget(gfxwin,w/2+3+25+(strlen(_locale[23])+1)*_CharWidth,ty,_CharWidth*4,_NBH+6,right_hbarheightstr,2,1,0,1,7,11);
    ty+=_NBH+6;
    ty+=5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[24]);
    _CreateText(gfxwin,w/2+3+5,ty+_GlobalGUI.font->ascent,1,_locale[24]);
    ty+=_BBH;
    _CreateText(gfxwin,35,ty+_GlobalGUI.font->ascent,1,_locale[25]);
    _CreateText(gfxwin,w/2+3+25,ty+_GlobalGUI.font->ascent,1,_locale[25]);
    tleftleft=_CreateChooseButton(gfxwin,35+(strlen(_locale[25])+1)*_CharWidth,ty,20,20,*tleftvbar_left,6);
    trightleft=_CreateChooseButton(gfxwin,w/2+3+25+(strlen(_locale[25])+1)*_CharWidth,ty,20,20,*trightvbar_left,8);
    ty+=_BBH+5;
    _CreateText(gfxwin,35,ty+_GlobalGUI.font->ascent,1,_locale[26]);
    _CreateText(gfxwin,w/2+3+25,ty+_GlobalGUI.font->ascent,1,_locale[26]);
    leftwidthsg=_CreateStringGadget(gfxwin,35+(strlen(_locale[26])+1)*_CharWidth,ty,_CharWidth*4,_NBH+6,left_vbarwidthstr,2,1,0,1,7,10);
    rightwidthsg=_CreateStringGadget(gfxwin,w/2+3+25+(strlen(_locale[26])+1)*_CharWidth,ty,_CharWidth*4,_NBH+6,right_vbarwidthstr,2,1,0,1,7,12);
    ty+=_NBH+6;
    ty+=5;
    ty+=10;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",3);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",4);
    end=FALSE;
    _RedrawWin(gfxwin);
    do {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            switch(tbutton->data) {
              case 3:*tlefthbar_top=tlefttop->data;
                     *tleftvbar_left=tleftleft->data;
                     *trighthbar_top=trighttop->data;
                     *trightvbar_left=trightleft->data;
                     *tlefthbar_height=atoi(leftheightsg->string);
                     *tleftvbar_width=atoi(leftwidthsg->string);
                     *trighthbar_height=atoi(rightheightsg->string);
                     *trightvbar_width=atoi(rightwidthsg->string);
                     end=TRUE;
                     break;
              case 4:end=TRUE;
                     break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==CHOOSE_GADGET) {
            tchoosebutton=(_ChooseButton*)msg->gadget;
            switch(tchoosebutton->data2) {
              case 5:leftlv->top=tchoosebutton->data;
                     break;
              case 6:leftlv->left=tchoosebutton->data;
                     break;
              case 7:rightlv->top=tchoosebutton->data;
                     break;
              case 8:rightlv->left=tchoosebutton->data;
                     break;
            }
            _RedrawWin(gfxwin);
          } else if(msg->gadgettype==STRING_GADGET) {
            report=(_StringGadget*)msg->gadget;
            q=atoi(report->string);
            switch(report->data) {
              case 9:if(q<5) {
                       q=5;
                       sprintf(report->string,"%d",5);
                       report->cursor=0;
                     }
                     if(q>80) {
                       q=80;
                       sprintf(report->string,"%d",80);
                       report->cursor=0;
                     }
                     leftlv->hbar_height=q;
                     break;
              case 10:if(q<5) {
                        q=5;
                        sprintf(report->string,"%d",5);
                        report->cursor=0;
                      }
                      if(q>80) {
                        q=80;
                        sprintf(report->string,"%d",80);
                        report->cursor=0;
                      }
                      leftlv->vbar_width=q;
                      break;
              case 11:if(q<5) {
                        q=5;
                        sprintf(report->string,"%d",5);
                        report->cursor=0;
                      }
                      if(q>80) {
                        q=80;
                        sprintf(report->string,"%d",80);
                        report->cursor=0;
                      }
                      rightlv->hbar_height=q;
                      break;
              case 12:if(q<5) {
                        q=5;
                        sprintf(report->string,"%d",5);
                        report->cursor=0;
                      }
                      if(q>80) {
                        q=80;
                        sprintf(report->string,"%d",80);
                        report->cursor=0;
                      }
                      rightlv->vbar_width=q;
                      break;
            }
            _RedrawWin(gfxwin);
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) end=TRUE;
        }
        _ReplyMessage(msg);
      }
    } while(end==FALSE);
    _CloseWindow(gfxwin);
  }
  _freesafe(left_hbarheightstr);
  _freesafe(left_vbarwidthstr);
  _freesafe(right_hbarheightstr);
  _freesafe(right_vbarwidthstr);
}

void WCSetPalette(struct _color *firstcolor,int tempmaxcol)
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg,*tmsg;
  _Button *tbutton;
  _Text *entrytext,*redtext,*greentext,*bluetext;
  _SolidButton *selcol;
  struct _color *tcol1,*tcol2=NULL,*localfirstcolor,*tcol3,*select;
  int count,x,y,end,ww,ww2,entry=0,delayer,bnr,changed;
  int temptype;
  XColor Color;
  char *entrystr,*redstr,*greenstr,*bluestr;
  struct timespec waittime;
  int h,okw,cw;
  
  entrystr=(char*)_allocsafe(4);
  redstr=(char*)_allocsafe(4);
  greenstr=(char*)_allocsafe(4);
  bluestr=(char*)_allocsafe(4);
  tcol1=firstcolor;
  count=0;
  do {
    count++;
    if(count<=tempmaxcol) tcol2=tcol1;
    tcol1=tcol1->next;
  } while(tcol1!=NULL);
  if(count<tempmaxcol) {
    while(count!=tempmaxcol) {
      tcol2->next=_CreateCColor(0,0,0);
      tcol2=tcol2->next;
      if(tcol2==NULL) {printf("No Memory!!!\n");break;}
      count++;
    }
  } else if(count>tempmaxcol) {
    tcol1=tcol2->next;
    tcol2->next=NULL;
    while(tcol1!=NULL) {
      tcol2=tcol1->next;
      _FreeCColor(tcol1);
      tcol1=tcol2;
    }
    count=tempmaxcol;
  }
  /* Hier sollten nun tempmaxcol Farben existieren, auf jeden Fall aber count Stck */
  if(ColCnt>count) {
    XFreeColors(_GlobalGUI.Dsp,_GlobalGUI.CMap,&ColBuf[count],ColCnt-count,0);    
    ColCnt=count;
  } else if(ColCnt<count) {
    Color.flags=DoRed|DoGreen|DoBlue;
    while(ColCnt<count) {
      Color.red=0;
      Color.green=0;
      Color.blue=0;
      if (!XAllocColor(_GlobalGUI.Dsp,_GlobalGUI.CMap,&Color)) { printf("Fehler bei Farberstellung!\n");break;}
      else ColBuf[ColCnt++]=Color.pixel;
    }
  }
  /* Jetzt stehen count Farben im ColBuf zur Verfgung */
  /* Hier nun lokale Kopie der Farben erstellen */
  tcol1=firstcolor;
  localfirstcolor=tcol2=NULL;
  while(tcol1!=NULL) {
    tcol3=_CreateCColor(tcol1->red,tcol1->green,tcol1->blue);
    if(tcol3==NULL) {printf("No Memory!!!\n");break;}
    if(tcol2==NULL) {
      localfirstcolor=tcol3;
    } else {
      tcol2->next=tcol3;
    }
    tcol2=tcol3;
    tcol1=tcol1->next;
  }
/*  select=localfirstcolor;
  entry=0;
  sprintf(entrystr,"%d",entry);*/
  select=NULL;
  x=strlen(_locale[28]);
  if(strlen(_locale[29])>x) x=strlen(_locale[29]);
  if(strlen(_locale[30])>x) x=strlen(_locale[30]);
  ww=272+5+3+_CharWidth*(strlen(_locale[27])+4)+15;
  ww2=272+5+3+_CharWidth*(x+6)+45+15;
  if(ww2>ww) ww=ww2;
  h=262+10+10+_BBH;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,ww,299,ww,ww,ww,299,299,299,0,_locale[15],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateBevelBox(gfxwin,10,10,262,262,NORMAL);
    _CreateBevelBox(gfxwin,272+5,10,ww-272-5-10,25+6*_CharHeight,HIGH);
    _CreateButton(gfxwin,10,276,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,ww-10-cw,276,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _CreateButton(gfxwin,280+(x+1)*_CharWidth,8+2*_CharHeight,20,20,_black,0,"<",FALSE,_white,2,"",3);
    _CreateButton(gfxwin,280+(x+1)*_CharWidth+22+5*_CharWidth,8+2*_CharHeight,20,20,_black,0,">",FALSE,_white,2,"",4);
    _CreateButton(gfxwin,280+(x+1)*_CharWidth,8+4*_CharHeight,20,20,_black,0,"<",FALSE,_white,2,"",5);
    _CreateButton(gfxwin,280+(x+1)*_CharWidth+22+5*_CharWidth,8+4*_CharHeight,20,20,_black,0,">",FALSE,_white,2,"",6);
    _CreateButton(gfxwin,280+(x+1)*_CharWidth,8+6*_CharHeight,20,20,_black,0,"<",FALSE,_white,2,"",7);
    _CreateButton(gfxwin,280+(x+1)*_CharWidth+22+5*_CharWidth,8+6*_CharHeight,20,20,_black,0,">",FALSE,_white,2,"",8);
    _CreateText(gfxwin,280,12+_GlobalGUI.font->ascent,1,_locale[27]);
    _CreateText(gfxwin,280,22+2*_CharHeight,1,_locale[28]);
    redtext=_CreateText(gfxwin,280+(x+2)*_CharWidth+22,22+2*_CharHeight,1,"    ");
    _CreateText(gfxwin,280,22+4*_CharHeight,1,_locale[29]);
    greentext=_CreateText(gfxwin,280+(x+2)*_CharWidth+22,22+4*_CharHeight,1,"    ");
    _CreateText(gfxwin,280,22+6*_CharHeight,1,_locale[30]);
    bluetext=_CreateText(gfxwin,280+(x+2)*_CharWidth+22,22+6*_CharHeight,1,"    ");
    entrytext=_CreateText(gfxwin,280+_CharWidth*strlen(_locale[27]),12+_GlobalGUI.font->ascent,1,"    ");
    for(y=0;y<16;y++) {
      if((y*16)>=count) break;
      for(x=0;x<16;x++) {
        if((y*16+x)>=count) break;
        _CreateButton(gfxwin,13+x*16,13+y*16,16,16,_black,y*16+x,"",FALSE,_white,2,"",9+y*16+x);
      }
    }
    selcol=_CreateSolidButton(gfxwin,290,45+6*_CharHeight,30,30,_black,0,"");
    end=FALSE;
    _RedrawWin(gfxwin);
    do {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              /* Okay */
              /* localfirstcolor mit firstcolor verbinden, die restlichen freilassen */
              tcol1=firstcolor;
              tcol3=localfirstcolor;
              tcol1->red=tcol3->red;
              tcol1->green=tcol3->green;
              tcol1->blue=tcol3->blue;
              tcol2=tcol1->next;
              tcol1->next=tcol3->next;
              _freesafe(tcol3);
              while(tcol2!=NULL) {
                tcol1=tcol2->next;
                _freesafe(tcol2);
                tcol2=tcol1;
              }
              end=TRUE;
            } else if(tbutton->data==2) {
              /* smtliche vernderten Farben wieder besorgen */
              /* Cancel */
              tcol1=firstcolor;
              tcol3=localfirstcolor;
              x=0;
              while(tcol1!=NULL) {
                if((tcol1->red!=tcol3->red)||(tcol1->green!=tcol3->green)||(tcol1->blue!=tcol3->blue)) {
                  Color.flags=DoRed|DoGreen|DoBlue;
                  Color.red=tcol1->red*256;
                  Color.green=tcol1->green*256;
                  Color.blue=tcol1->blue*256;
                  if (!XAllocColor(_GlobalGUI.Dsp,_GlobalGUI.CMap,&Color)) {
                    printf("Fehler bei Farberstellung!\n");
                  } else {
                    XFreeColors(_GlobalGUI.Dsp,_GlobalGUI.CMap,&ColBuf[x],1,0);
                    ColBuf[x]=Color.pixel;
                  }
                }
                tcol1=tcol1->next;
                tcol2=tcol3->next;
                _freesafe(tcol3);
                tcol3=tcol2;
                x++;
              }
              end=TRUE;
            } else if(tbutton->data>8) {
              entry=tbutton->data-9;
              sprintf(entrystr,"%d",entry);
              strcpy(entrytext->text,entrystr);
              select=localfirstcolor;
              for(y=0;y<entry;y++) {
                select=select->next;
              }
            }
            if(select!=NULL) {
              selcol->bg=entry;
              sprintf(redstr,"%d",select->red);
              strcpy(redtext->text,redstr);
              sprintf(greenstr,"%d",select->green);
              strcpy(greentext->text,greenstr);
              sprintf(bluestr,"%d",select->blue);
              strcpy(bluetext->text,bluestr);
              _RedrawWin(gfxwin);
            }
          }
        } else if(msg->type==ButtonPress) {
          if(select!=NULL) {
            if(msg->gadgettype==BUTTON_GADGET) {
              tbutton=(_Button*)msg->gadget;
              bnr=tbutton->data;
              changed=FALSE;
              if(bnr>2&&bnr<9) {
                delayer=0;
                waittime.tv_sec=0;
                waittime.tv_nsec=50*1000000;
                do {
                  if(delayer>1) delayer--;
                  if(delayer<2) {
                    if((bnr==3)&&(select->red>0)) {
                      changed=TRUE;
                      if(msg->button==Button1) select->red--;
                      else {
                        select->red-=2;
                        if(select->red==255) select->red=0;
                      }
                      sprintf(redstr,"%d",select->red);
                      strcpy(redtext->text,redstr);
                    } else if((bnr==4)&&(select->red<255)) {
                      changed=TRUE;
                      if(msg->button==Button1) select->red++;
                      else {
                        select->red+=2;
                        if(select->red==0) select->red=255;
                      }
                      sprintf(redstr,"%d",select->red);
                      strcpy(redtext->text,redstr);
                    } else if((bnr==5)&&(select->green>0)) {
                      changed=TRUE;
                      if(msg->button==Button1) select->green--;
                      else {
                        select->green-=2;
                        if(select->green==255) select->green=0;
                      }
                      sprintf(greenstr,"%d",select->green);
                      strcpy(greentext->text,greenstr);
                    } else if((bnr==6)&&(select->green<255)) {
                      changed=TRUE;
                      if(msg->button==Button1) select->green++;
                      else {
                        select->green+=2;
                        if(select->green==0) select->green=255;
                      }
                      sprintf(greenstr,"%d",select->green);
                      strcpy(greentext->text,greenstr);
                    } else if((bnr==7)&&(select->blue>0)) {
                      changed=TRUE;
                      if(msg->button==Button1) select->blue--;
                      else {
                        select->blue-=2;
                        if(select->blue==255) select->blue=0;
                      }
                      sprintf(bluestr,"%d",select->blue);
                      strcpy(bluetext->text,bluestr);
                    } else if((bnr==8)&&(select->blue<255)) {
                      changed=TRUE;
                      if(msg->button==Button1) select->blue++;
                      else {
                        select->blue+=2;
                        if(select->blue==0) select->blue=255;
                      }
                      sprintf(bluestr,"%d",select->blue);
                      strcpy(bluetext->text,bluestr);
                    }
                    if(changed==TRUE) {
                      Color.flags=DoRed|DoGreen|DoBlue;
                      Color.red=select->red*256;
                      Color.green=select->green*256;
                      Color.blue=select->blue*256;
                      if (!XAllocColor(_GlobalGUI.Dsp,_GlobalGUI.CMap,&Color)) {
                        printf("Fehler bei Farberstellung!\n");
                      } else {
                        XFreeColors(_GlobalGUI.Dsp,_GlobalGUI.CMap,&ColBuf[entry],1,0);
                        ColBuf[entry]=Color.pixel;
                      }
                      _RedrawWin(gfxwin);
                      changed=FALSE;
                    }
                    if(delayer==0) delayer=10;
                  }
                  tmsg=_GetMessage(gfxwin);
                  if(tmsg!=NULL) {
                    temptype=tmsg->type;
                    if(temptype==ButtonRelease) {
                      _ReplyMessage(tmsg);
                      break;
                    }
                  }
                  nanosleep(&waittime,NULL);
                  _ReplyMessage(tmsg);
                } while (1);
              }
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            /* smtliche vernderten Farben wieder besorgen */
            /* Cancel */
            tcol1=firstcolor;
            tcol3=localfirstcolor;
            x=0;
            while(tcol1!=NULL) {
              if((tcol1->red!=tcol3->red)||(tcol1->green!=tcol3->green)||(tcol1->blue!=
              tcol3->blue)) {
                Color.flags=DoRed|DoGreen|DoBlue;
                Color.red=tcol1->red*256;
                Color.green=tcol1->green*256;
                Color.blue=tcol1->blue*256;
                if (!XAllocColor(_GlobalGUI.Dsp,_GlobalGUI.CMap,&Color)) {
                  printf("Fehler bei Farberstellung!\n");
                } else {
                  XFreeColors(_GlobalGUI.Dsp,_GlobalGUI.CMap,&ColBuf[x],1,0);
                  ColBuf[x]=Color.pixel;
                }
              }
              tcol1=tcol1->next;
              tcol2=tcol3->next;
              _freesafe(tcol3);
              tcol3=tcol2;
              x++;
            }
            end=TRUE;
          }
        }
        _ReplyMessage(msg);
      }
    } while(end==FALSE);
    _CloseWindow(gfxwin);
  }
  _freesafe(entrystr);
  _freesafe(redstr);
  _freesafe(greenstr);
  _freesafe(bluestr);
  return;
}

void WCChangeGLBL()
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg,*tmsg;
  _Button *tbutton=NULL,*langbutton;
  _Text *colorcountt,*ytext,*xtext;
  struct _color *firstcolor,*tcolor1,*tcolor2,*tcolor3;
  char maxcolstr[4];
  char xbuttons[4],ybuttons[4];
  char *newlang;
  int tempmaxcol,temptype,delayer,tempxbuttons,tempybuttons;
  int x1,x2,x3,x,w;
  int length[5],okw,cw,h,ty;
  bool cancel=FALSE;
  bool tlefthbar_top;
  bool tleftvbar_left;
  int tlefthbar_height;
  int tleftvbar_width;
  bool trighthbar_top;
  bool trightvbar_left;
  int trighthbar_height;
  int trightvbar_width;
  struct timespec waittime;
  XColor Color;
  length[0]=10+strlen(_locale[9])*_CharWidth+120+10;
  length[1]=15+strlen(_locale[14])*_CharWidth+22+5*_CharWidth+20+15;
  length[2]=strlen(_locale[16])*_CharWidth+20+40;
  length[3]=15+(strlen(_locale[17])+1)*_CharWidth+22+5*_CharWidth+20+15;
  length[4]=15+(strlen(_locale[18])+1)*_CharWidth+22+5*_CharWidth+20+15;
  for(x1=0,x2=length[0];x1<5;x1++) if(length[x1]>x2) x2=length[x1];
  w=x2;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  h=5;
  h+=_NBH+5;
  h+=5;
  h+=_BBH+5;
  h+=_BBH+5+5;
  h+=_BBH+5;
  h+=5;
  h+=_BBH+5;
  h+=_BBH+10;
  h+=_BBH+5;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[1],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    tcolor1=LConfig.first;
    tcolor2=_CreateCColor(tcolor1->red,tcolor1->green,tcolor1->blue);
    if(tcolor2==NULL) {
      _CloseWindow(gfxwin);
      return;
    }
    firstcolor=tcolor2;
    while((tcolor3=tcolor1->next)!=NULL) {
      tcolor1=tcolor3;
      tcolor2->next=_CreateCColor(tcolor1->red,tcolor1->green,tcolor1->blue);
      tcolor2=tcolor2->next;
      if(tcolor2==NULL) break;
    }
    sprintf(maxcolstr,"%d",LConfig.colors);
    sprintf(xbuttons,"%d",LConfig.numxbuttons);
    sprintf(ybuttons,"%d",LConfig.numybuttons);
    tempxbuttons=LConfig.numxbuttons;
    tempybuttons=LConfig.numybuttons;
    tempmaxcol=LConfig.colors;
    tlefthbar_top=LConfig.lefthbar_top;
    tleftvbar_left=LConfig.leftvbar_left;
    tlefthbar_height=LConfig.lefthbar_height;
    tleftvbar_width=LConfig.leftvbar_width;
    trighthbar_top=LConfig.righthbar_top;
    trightvbar_left=LConfig.rightvbar_left;
    trighthbar_height=LConfig.righthbar_height;
    trightvbar_width=LConfig.rightvbar_width;
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[9]);
    langbutton=_CreateButton(gfxwin,10+strlen(_locale[9])*_CharWidth,ty,w-20-strlen(_locale[9])*_CharWidth,_NBH,_black,0,LConfig.lang,FALSE,_white,2,"",3);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,strlen(_locale[14])*_CharWidth+53+5*_CharWidth,2*_BBH+15,HIGH);
    ty+=5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[14]);
    _CreateButton(gfxwin,15+strlen(_locale[14])*_CharWidth+2,ty-2,_BBH,_BBH,_black,0,"<",FALSE,_white,2,"",6);
    _CreateButton(gfxwin,15+strlen(_locale[14])*_CharWidth+22+5*_CharWidth,ty-2,_BBH,_BBH,_black,0,">",FALSE,_white,2,"",7);
    colorcountt=_CreateText(gfxwin,15+strlen(_locale[14])*_CharWidth+28,ty+_GlobalGUI.font->ascent,1,maxcolstr);
    ty+=_BBH+5;
    _CreateButton(gfxwin,20,ty,strlen(_locale[14])*_CharWidth+33+5*_CharWidth,_BBH,_black,0,_locale[15],FALSE,_white,2,"",8);
    ty+=_BBH+5+5;
    _CreateButton(gfxwin,10,ty,strlen(_locale[16])*_CharWidth+20,_BBH,_black,0,_locale[16],FALSE,_white,2,"",9);
    ty+=_BBH+5;
    x1=(strlen(_locale[17])+1)*_CharWidth;
    x2=(strlen(_locale[18])+1)*_CharWidth;
    x3=x1<x2 ? x2 :x1;
    _CreateBevelBox(gfxwin,10,ty,x3+5*_CharWidth+54,2*_BBH+15,HIGH);
    ty+=5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[17]);
    _CreateButton(gfxwin,15+x3+2,ty-2,_BBH,_BBH,_black,0,"<",FALSE,_white,2,"",10);
    _CreateButton(gfxwin,15+x3+22+5*_CharWidth,ty-2,_BBH,_BBH,_black,0,">",FALSE,_white,2,"",11);
    ytext=_CreateText(gfxwin,15+x3+28,ty+_GlobalGUI.font->ascent,1,ybuttons);
    ty+=_BBH+5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[18]);
    _CreateButton(gfxwin,15+x3+2,ty-2,_BBH,_BBH,_black,0,"<",FALSE,_white,2,"",12);
    _CreateButton(gfxwin,15+x3+22+5*_CharWidth,ty-2,_BBH,_BBH,_black,0,">",FALSE,_white,2,"",13);
    xtext=_CreateText(gfxwin,15+x3+28,ty+_GlobalGUI.font->ascent,1,xbuttons);
    ty+=_BBH+10;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) cancel=TRUE;
        }
        if((msg->type==ButtonRelease)||(cancel==TRUE)) {
          if((msg->gadgettype==BUTTON_GADGET)||(cancel==TRUE)) {
            if(cancel==TRUE) x1=2;
            else {
              tbutton=(_Button*)msg->gadget;
              x1=tbutton->data;
            }
            switch(x1) {
              case 1:tcolor1=LConfig.first;
                     tcolor3=firstcolor;
                     tcolor1->red=tcolor3->red;
                     tcolor1->green=tcolor3->green;
                     tcolor1->blue=tcolor3->blue;
                     tcolor2=tcolor1->next;
                     tcolor1->next=tcolor3->next;
                     _freesafe(tcolor3);
                     while(tcolor2!=NULL) {
                       tcolor1=tcolor2->next;
                       _freesafe(tcolor2);
                       tcolor2=tcolor1;
                     }
                     LConfig.colors=tempmaxcol;
                     /* Alle restlichen Werte auswerten */
                     newlang=(char*)_allocsafe(strlen(langbutton->text_normal)+1);
                     if(newlang==NULL) printf("No Memory!!!\n");
                     else {
                       strcpy(newlang,langbutton->text_normal);
                       _freesafe(LConfig.lang);
                       LConfig.lang=newlang;
                     }
                     LConfig.numxbuttons=tempxbuttons;
                     LConfig.numybuttons=tempybuttons;
                     LConfig.lefthbar_top=tlefthbar_top;
                     LConfig.leftvbar_left=tleftvbar_left;
                     LConfig.lefthbar_height=tlefthbar_height;
                     LConfig.leftvbar_width=tleftvbar_width;
                     LConfig.righthbar_top=trighthbar_top;
                     LConfig.rightvbar_left=trightvbar_left;
                     LConfig.righthbar_height=trighthbar_height;
                     LConfig.rightvbar_width=trightvbar_width;
                     break;
              case 2:tcolor1=LConfig.first;
                     tcolor3=firstcolor;
                     x=0;
                     while(tcolor1!=NULL) {
                       if(tcolor3!=NULL) {
                         if((tcolor1->red!=tcolor3->red)||(tcolor1->green!=tcolor3->green)||(tcolor1->blue!=tcolor3->blue)) {
                           Color.flags=DoRed|DoGreen|DoBlue;
                           Color.red=tcolor1->red*256;
                           Color.green=tcolor1->green*256;
                           Color.blue=tcolor1->blue*256;
                           if (!XAllocColor(_GlobalGUI.Dsp,_GlobalGUI.CMap,&Color)) {
                             printf("Fehler bei Farberstellung!\n");
                           } else {
                             XFreeColors(_GlobalGUI.Dsp,_GlobalGUI.CMap,&ColBuf[x],1,0);
                             ColBuf[x]=Color.pixel;
                           }                         
                         }
                       } else {
                         Color.flags=DoRed|DoGreen|DoBlue;
                         Color.red=tcolor1->red*256;
                         Color.green=tcolor1->green*256;
                         Color.blue=tcolor1->blue*256;
                         if (!XAllocColor(_GlobalGUI.Dsp,_GlobalGUI.CMap,&Color)) {
                           printf("Fehler bei Farberstellung!\n");
                         } else {
                           ColBuf[x]=Color.pixel;
                           ColCnt++;
                         }
                       }
                       tcolor1=tcolor1->next;
                       if(tcolor3!=NULL) {
                         tcolor2=tcolor3->next;
                         _freesafe(tcolor3);
                         tcolor3=tcolor2;
                       }
                       x++;
                     }
                     if(x<ColCnt) {
                       XFreeColors(_GlobalGUI.Dsp,_GlobalGUI.CMap,&ColBuf[x],ColCnt-x,0);
                       ColCnt=x;
                     }
                     break;
              case 3:newlang=WCSelectLang();
                     if(newlang!=NULL) {
                       _freesafe(langbutton->text_normal);
                       langbutton->text_normal=newlang;
                     }
                     _RedrawWin(gfxwin);
                     break;
              case 8:WCSetPalette(firstcolor,tempmaxcol);
                     _RedrawWin(gfxwin);
                     break;
              case 9:WCSetLister(&tlefthbar_top,&tleftvbar_left,&tlefthbar_height,&tleftvbar_width,&trighthbar_top,&trightvbar_left,&trighthbar_height,&trightvbar_width);
                     break;
              case 10:if(tempybuttons>1) {
                        tempybuttons--;
                        sprintf(ybuttons,"%d",tempybuttons);
                        strcpy(ytext->text,ybuttons);
                        _SetFG(gfxwin,gfxwin->bg);
                        _FillRectangle(gfxwin,ytext->x,ytext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2,BUFFER);
                        _GUIDrawText(gfxwin,ytext,BUFFER);
                        _FlushWin(gfxwin,ytext->x,ytext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2);
                      }
                      break;
              case 11:if(tempybuttons<10) {
                        tempybuttons++;
                        sprintf(ybuttons,"%d",tempybuttons);
                        strcpy(ytext->text,ybuttons);
                        _SetFG(gfxwin,gfxwin->bg);
                        _FillRectangle(gfxwin,ytext->x,ytext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2,BUFFER);
                        _GUIDrawText(gfxwin,ytext,BUFFER);
                        _FlushWin(gfxwin,ytext->x,ytext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2);
                      }
                      break;
              case 12:if(tempxbuttons>1) {
                        tempxbuttons--;
                        sprintf(xbuttons,"%d",tempxbuttons);
                        strcpy(xtext->text,xbuttons);
                        _SetFG(gfxwin,gfxwin->bg);
                        _FillRectangle(gfxwin,xtext->x,xtext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2,BUFFER);
                        _GUIDrawText(gfxwin,xtext,BUFFER);
                        _FlushWin(gfxwin,xtext->x,xtext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2);
                      }
                      break;
              case 13:if(tempxbuttons<20) {
                        tempxbuttons++;
                        sprintf(xbuttons,"%d",tempxbuttons);
                        strcpy(xtext->text,xbuttons);
                        _SetFG(gfxwin,gfxwin->bg);
                        _FillRectangle(gfxwin,xtext->x,xtext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2,BUFFER);
                        _GUIDrawText(gfxwin,xtext,BUFFER);
                        _FlushWin(gfxwin,xtext->x,xtext->y-_CharHeight,3*_CharWidth,_CharHeight*1.2);
                      }
                      break;
            }
            if(cancel==TRUE) {
              _ReplyMessage(msg);
              break;
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            switch(tbutton->data) {
              case 6:if(tempmaxcol>8) {
                       delayer=0;
                       waittime.tv_sec=0;
                       waittime.tv_nsec=50*1000000;
                       do {
                         if(delayer>1) delayer--;
                         if(delayer<2) {
                           if(tempmaxcol>8) {
                             tempmaxcol--;
                             sprintf(maxcolstr,"%d",tempmaxcol);
                             strcpy(colorcountt->text,maxcolstr);
                             _SetFG(gfxwin,gfxwin->bg);
                             _FillRectangle(gfxwin,colorcountt->x,colorcountt->y-_CharHeight,3*_CharWidth,_CharHeight*1.2,BUFFER);
                             _GUIDrawText(gfxwin,colorcountt,BUFFER);
                             _FlushWin(gfxwin,colorcountt->x,colorcountt->y-_CharHeight,3*_CharWidth,_CharHeight*1.2);
                           }
                           if(delayer==0) delayer=10;
                         }
                         tmsg=_GetMessage(gfxwin);
                         if(tmsg!=NULL) {
                           temptype=tmsg->type;
                           if(temptype==ButtonRelease) {
                             _ReplyMessage(tmsg);
                             break;
                           }
                         }
                         nanosleep(&waittime,NULL);
                         _ReplyMessage(tmsg);
                       } while (1);
                     }
                     break;  
              case 7:if(tempmaxcol<256) {
                       delayer=0;
                       waittime.tv_sec=0;
                       waittime.tv_nsec=50*1000000;
                       do {
                         if(delayer>1) delayer--;
                         if(delayer<2) {
                           if(tempmaxcol<256) {
                             tempmaxcol++;
                             sprintf(maxcolstr,"%d",tempmaxcol);
                             strcpy(colorcountt->text,maxcolstr);
                             _SetFG(gfxwin,gfxwin->bg);
                             _FillRectangle(gfxwin,colorcountt->x,colorcountt->y-_CharHeight,3*_CharWidth,_CharHeight*1.2,BUFFER);
                             _GUIDrawText(gfxwin,colorcountt,BUFFER);
                             _FlushWin(gfxwin,colorcountt->x,colorcountt->y-_CharHeight,3*_CharWidth,_CharHeight*1.2);
                           }
                           if(delayer==0) delayer=10;
                         }
                         tmsg=_GetMessage(gfxwin);
                         if(tmsg!=NULL) {
                           temptype=tmsg->type;
                           if(temptype==ButtonRelease) {
                             _ReplyMessage(tmsg);
                             break;
                           }
                         }
                         nanosleep(&waittime,NULL);
                         _ReplyMessage(tmsg);
                       } while (1);
                     }
                     break;
            }
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
}

int WCPalette(int initcol)
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _SolidButton *selcol;
  int x,y,rows,coloums,size,end,sel=-1,bg,okw,cw;
  float fx;
  x=LConfig.colors;
  fx=sqrt(x);
  x=fx;
  if(fx==x) coloums=x; else coloums=x+1;
  rows=coloums;
  size=256/coloums;
  sel=-1;
  if(initcol>=0) {
    bg=initcol;
    sel=bg;
  } else bg=0;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,350,300,350,350,350,300,300,300,0,_locale[45],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateButton(gfxwin,10,275,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,350-10-cw,275,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _CreateBevelBox(gfxwin,10,10,262,262,HIGH);
    selcol=_CreateSolidButton(gfxwin,282,30,50,50,0,bg,"");
    for(y=0;y<rows;y++) {
      for(x=0;x<coloums;x++) {
        _CreateButton(gfxwin,13+x*size,13+y*size,size,size,_black,y*rows+x,"",FALSE,_white,2,"",3+y*rows+x);
        if(y*rows+x>=(LConfig.colors-1)) break;
      }
      if(y*rows+x>=(LConfig.colors-1)) break;
    }
    end=FALSE;
    _RedrawWin(gfxwin);
    do {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data>2) {
              sel=tbutton->data-3;
              selcol->bg=sel;
              _RedrawWin(gfxwin);
            } else if(tbutton->data==1) {
              end=TRUE;
            } else {
              sel=-1;
              end=TRUE;
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            sel=-1;
            end=TRUE;
          }
        }
        _ReplyMessage(msg);
      }
    } while(end==FALSE);
    _CloseWindow(gfxwin);
  }    
  return sel;
}

void WCChangeCOLD()
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _SolidButton *statebar,*sel_lvb,*unsel_lvb,*clockbar,*requestbar;
  _ListView *lv;
  _ListViewContent *seldir,*selfile,*unseldir,*unselfile;
  _StringGadget *path;
  int x,x2,x3;
  int cwidth[11],okw,cw,w,h,ty;
  cwidth[0]=strlen(_locale[31]);
  cwidth[1]=strlen(_locale[34]);
  cwidth[2]=strlen(_locale[35]);
  cwidth[3]=strlen(_locale[36])+2;
  cwidth[4]=strlen(_locale[37])+2;
  cwidth[5]=strlen(_locale[38])+2;
  cwidth[6]=strlen(_locale[39])+2;
  cwidth[7]=strlen(_locale[41]);
  cwidth[8]=strlen(_locale[42]);
  cwidth[9]=strlen(_locale[43]);
  cwidth[10]=strlen(_locale[44]);
  for(x=0,x2=0;x<11;x++) {
    if(cwidth[x]>x2) x2=cwidth[x];
  }
  w=x2;
  w+=strlen(_locale[32])+strlen(_locale[33])+6;
  w*=_CharWidth;
  w+=10+10+10+10;
  
  if(LConfig.statusbarfg>=LConfig.colors) LConfig.statusbarfg=LConfig.colors-1;
  if(LConfig.statusbarbg>=LConfig.colors) LConfig.statusbarbg=LConfig.colors-1;
  if(LConfig.sel_lvbfg>=LConfig.colors) LConfig.sel_lvbfg=LConfig.colors-1;
  if(LConfig.sel_lvbbg>=LConfig.colors) LConfig.sel_lvbbg=LConfig.colors-1;
  if(LConfig.unsel_lvbfg>=LConfig.colors) LConfig.unsel_lvbfg=LConfig.colors-1;
  if(LConfig.unsel_lvbbg>=LConfig.colors) LConfig.unsel_lvbbg=LConfig.colors-1;
  if(LConfig.sel_dirfg>=LConfig.colors) LConfig.sel_dirfg=LConfig.colors-1;
  if(LConfig.sel_dirbg>=LConfig.colors) LConfig.sel_dirbg=LConfig.colors-1;
  if(LConfig.unsel_dirfg>=LConfig.colors) LConfig.unsel_dirfg=LConfig.colors-1;
  if(LConfig.unsel_dirbg>=LConfig.colors) LConfig.unsel_dirbg=LConfig.colors-1;
  if(LConfig.sel_filefg>=LConfig.colors) LConfig.sel_filefg=LConfig.colors-1;
  if(LConfig.sel_filebg>=LConfig.colors) LConfig.sel_filebg=LConfig.colors-1;
  if(LConfig.unsel_filefg>=LConfig.colors) LConfig.unsel_filefg=LConfig.colors-1;
  if(LConfig.unsel_filebg>=LConfig.colors) LConfig.unsel_filebg=LConfig.colors-1;
  if(LConfig.clockbarfg>=LConfig.colors) LConfig.clockbarfg=LConfig.colors-1;
  if(LConfig.clockbarbg>=LConfig.colors) LConfig.clockbarbg=LConfig.colors-1;
  if(LConfig.requestfg>=LConfig.colors) LConfig.requestfg=LConfig.colors-1;
  if(LConfig.requestbg>=LConfig.colors) LConfig.requestbg=LConfig.colors-1;
  if(LConfig.sel_pathfg>=LConfig.colors) LConfig.sel_pathfg=LConfig.colors-1;
  if(LConfig.sel_pathbg>=LConfig.colors) LConfig.sel_pathbg=LConfig.colors-1;
  if(LConfig.unsel_pathfg>=LConfig.colors) LConfig.unsel_pathfg=LConfig.colors-1;
  if(LConfig.unsel_pathbg>=LConfig.colors) LConfig.unsel_pathbg=LConfig.colors-1;                     
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  h=5;
  h+=_NBH+5;
  h+=7;
  h+=_NBH+5;
  h+=_NBH+5;
  h+=7;
  h+=_NBH;
  h+=_NBH;
  h+=_NBH;
  h+=_NBH+5;
  h+=7;
  h+=_NBH+6+5;
  h+=_NBH+5;
  h+=_NBH+5;
  h+=7;
  h+=_NBH+5;
  h+=7;
  h+=_NBH+5;
  h+=7;
  h+=_BBH+5;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[2],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    x=_CharWidth*(strlen(_locale[31])+2);
    statebar=_CreateSolidButton(gfxwin,10,ty,x,_NBH,LConfig.statusbarfg,LConfig.statusbarbg,_locale[31]);
    x=x+10+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",3);
    x=x+_CharWidth*(strlen(_locale[32])+2)+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",4);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,2,NORMAL);
    ty+=7;
    x=_CharWidth*(strlen(_locale[34])+2);
    sel_lvb=_CreateSolidButton(gfxwin,10,ty,x,_NBH,LConfig.sel_lvbfg,LConfig.sel_lvbbg,_locale[34]);
    x=x+10+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",5);
    x=x+_CharWidth*(strlen(_locale[32])+2)+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",6);
    ty+=_NBH+5;
    x=_CharWidth*(strlen(_locale[35])+2);
    unsel_lvb=_CreateSolidButton(gfxwin,10,ty,x,_NBH,LConfig.unsel_lvbfg,LConfig.unsel_lvbbg,_locale[35]);
    x=x+10+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",7);
    x=x+_CharWidth*(strlen(_locale[32])+2)+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",8);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,2,NORMAL);
    ty+=7;
    x2=strlen(_locale[36]);
    for(x=1;x<4;x++) {
      if(strlen(_locale[36+x])>x2) x2=strlen(_locale[36+x]);
    }
    x=(x2+4)*_CharWidth;
    lv=_CreateListView(gfxwin,10,ty,x,4*_NBH,FALSE,FALSE,10,FALSE,FALSE,10,NULL,9);
    unseldir=_AddListViewContent(lv,NULL,_locale[36],10);
    unseldir->fg_normal=LConfig.unsel_dirfg;
    unseldir->bg_normal=LConfig.unsel_dirbg;
    unseldir->fg_select=LConfig.unsel_dirfg;
    unseldir->bg_select=LConfig.unsel_dirbg;
    seldir=_AddListViewContent(lv,unseldir,_locale[37],11);
    seldir->fg_normal=LConfig.sel_dirfg;
    seldir->bg_normal=LConfig.sel_dirbg;
    seldir->fg_select=LConfig.sel_dirfg;
    seldir->bg_select=LConfig.sel_dirbg;
    unselfile=_AddListViewContent(lv,seldir,_locale[38],12);
    unselfile->fg_normal=LConfig.unsel_filefg;
    unselfile->bg_normal=LConfig.unsel_filebg;
    unselfile->fg_select=LConfig.unsel_filefg;
    unselfile->bg_select=LConfig.unsel_filebg;
    selfile=_AddListViewContent(lv,unselfile,_locale[39],13);
    selfile->fg_normal=LConfig.sel_filefg;
    selfile->bg_normal=LConfig.sel_filebg;
    selfile->fg_select=LConfig.sel_filefg;
    selfile->bg_select=LConfig.sel_filebg;
    _CreateButton(gfxwin,20+x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",14);
    x3=_CharWidth*(strlen(_locale[32])+2)+10;
    _CreateButton(gfxwin,20+x+x3,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",15);
    ty+=_NBH;
    _CreateButton(gfxwin,20+x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",16);
    _CreateButton(gfxwin,20+x+x3,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",17);
    ty+=_NBH;
    _CreateButton(gfxwin,20+x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",18);
    _CreateButton(gfxwin,20+x+x3,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",19);
    ty+=_NBH;
    _CreateButton(gfxwin,20+x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",20);
    _CreateButton(gfxwin,20+x+x3,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",21);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,2,NORMAL);
    ty+=7;
    path=_CreateStringGadget(gfxwin,10,ty,50,_NBH+6,_locale[40],strlen(_locale[40])+5,LConfig.unsel_pathfg,LConfig.unsel_pathbg,LConfig.sel_pathfg,LConfig.sel_pathbg,22);
    ty+=_NBH+6+5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[41]);
    x=strlen(_locale[41]);
    if(strlen(_locale[42])>x) x=strlen(_locale[42]);
    x=x*_CharWidth;
    _CreateButton(gfxwin,15+x,ty-2,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",23);
    _CreateButton(gfxwin,15+x+x3,ty-2,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",24);
    ty+=_NBH+5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[42]);
    _CreateButton(gfxwin,15+x,ty-2,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",25);
    _CreateButton(gfxwin,15+x+x3,ty-2,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",26);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,2,NORMAL);
    ty+=7;
    x=_CharWidth*(strlen(_locale[43])+2);
    clockbar=_CreateSolidButton(gfxwin,10,ty,x,_NBH,LConfig.clockbarfg,LConfig.clockbarbg,_locale[43]);
    x=x+10+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",27);
    x=x+_CharWidth*(strlen(_locale[32])+2)+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",28);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,2,NORMAL);
    ty+=7;
    x=_CharWidth*(strlen(_locale[44])+2);
    requestbar=_CreateSolidButton(gfxwin,10,ty,x,_NBH,LConfig.requestfg,LConfig.requestbg,_locale[44]);
    x=x+10+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",29);
    x=x+_CharWidth*(strlen(_locale[32])+2)+10;
    _CreateButton(gfxwin,x,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",30);
    ty+=_NBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,2,NORMAL);
    ty+=7;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            switch(tbutton->data) {
              case 1:LConfig.statusbarfg=statebar->fg;
                     LConfig.statusbarbg=statebar->bg;
                     LConfig.sel_lvbfg=sel_lvb->fg;
                     LConfig.sel_lvbbg=sel_lvb->bg;
                     LConfig.unsel_lvbfg=unsel_lvb->fg;
                     LConfig.unsel_lvbbg=unsel_lvb->bg;
                     LConfig.sel_dirfg=seldir->fg_normal;
                     LConfig.sel_dirbg=seldir->bg_normal;
                     LConfig.unsel_dirfg=unseldir->fg_normal;
                     LConfig.unsel_dirbg=unseldir->bg_normal;
                     LConfig.sel_filefg=selfile->fg_normal;
                     LConfig.sel_filebg=selfile->bg_normal;
                     LConfig.unsel_filefg=unselfile->fg_normal;
                     LConfig.unsel_filebg=unselfile->bg_normal;
                     LConfig.clockbarfg=clockbar->fg;
                     LConfig.clockbarbg=clockbar->bg;
                     LConfig.requestfg=requestbar->fg;
                     LConfig.requestbg=requestbar->bg;
                     LConfig.sel_pathfg=path->fg_high;
                     LConfig.sel_pathbg=path->bg_high;
                     LConfig.unsel_pathfg=path->fg_normal;
                     LConfig.unsel_pathbg=path->bg_normal;
                     break;
              case 3:x=statebar->fg;
                     x=WCPalette(x);
                     if(x>=0) {
                        statebar->fg=x;
                       _RedrawWin(gfxwin);
                     }
                     break;
              case 4:x=statebar->bg;
                     x=WCPalette(x);
                     if(x>=0) {
                       statebar->bg=x;
                       _RedrawWin(gfxwin);
                     }
                     break;
              case 5:x=sel_lvb->fg;
                     x=WCPalette(x);
                     if(x>=0) {
                        sel_lvb->fg=x;
                       _RedrawWin(gfxwin);
                     }
                     break;
              case 6:x=sel_lvb->bg;
                     x=WCPalette(x);
                     if(x>=0) {
                       sel_lvb->bg=x;
                       _RedrawWin(gfxwin);
                     }
                     break;
              case 7:x=unsel_lvb->fg;
                     x=WCPalette(x);
                     if(x>=0) {
                       unsel_lvb->fg=x;
                       _RedrawWin(gfxwin);
                     }
                     break;
              case 8:x=unsel_lvb->bg;
                     x=WCPalette(x);
                     if(x>=0) {
                       unsel_lvb->bg=x;
                       _RedrawWin(gfxwin);
                     }
                     break;
              case 14:x=unseldir->fg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        unseldir->fg_normal=x;
                        unseldir->fg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 15:x=unseldir->bg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        unseldir->bg_normal=x;
                        unseldir->bg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 16:x=seldir->fg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        seldir->fg_normal=x;
                        seldir->fg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 17:x=seldir->bg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        seldir->bg_normal=x;
                        seldir->bg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 18:x=unselfile->fg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        unselfile->fg_normal=x;
                        unselfile->fg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 19:x=unselfile->bg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        unselfile->bg_normal=x;
                        unselfile->bg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 20:x=selfile->fg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        selfile->fg_normal=x;
                        selfile->fg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 21:x=selfile->bg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                         selfile->bg_normal=x;
                         selfile->bg_select=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 23:x=path->fg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                         path->fg_normal=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 24:x=path->bg_normal;
                      x=WCPalette(x);
                      if(x>=0) {
                        path->bg_normal=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 25:x=path->fg_high;
                      x=WCPalette(x);
                      if(x>=0) {
                        path->fg_high=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 26:x=path->bg_high;
                      x=WCPalette(x);
                      if(x>=0) {
                        path->bg_high=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 27:x=clockbar->fg;
                      x=WCPalette(x);
                      if(x>=0) {
                        clockbar->fg=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 28:x=clockbar->bg;
                      x=WCPalette(x);
                      if(x>=0) {
                        clockbar->bg=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 29:x=requestbar->fg;
                      x=WCPalette(x);
                      if(x>=0) {
                        requestbar->fg=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
              case 30:x=requestbar->bg;
                      x=WCPalette(x);
                      if(x>=0) {
                        requestbar->bg=x;
                        _RedrawWin(gfxwin);
                      }
                      break;
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
}

void WCChangeStartup(void)
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *ldirsg,*rdirsg;
  char *tldir,*trdir;
  int x,x2,height,okw,cw,ty;
  x=strlen(_locale[46]);
  if(strlen(_locale[47])>x) x=strlen(_locale[47]);
  x+=2;
  x2=strlen(_locale[8])+strlen(_locale[11])+2+2+5;
  if(x2>x) x=x2;
  x*=_CharWidth;
  x+=10+10;
  height=5;
  height+=_NBH+5;
  height+=_NBH+6+5;
  height+=_NBH+5;
  height+=_NBH+6+5;
  height+=_BBH+5;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,x,height,x,x,x,height,height,height,0,_locale[3],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[46]);
    ty+=_NBH+5;
    ldirsg=_CreateStringGadget(gfxwin,20,ty,x-30,_NBH+6,LConfig.ldir,256,1,0,1,7,3);
    ty+=_NBH+6+5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[47]);
    ty+=_NBH+5;
    rdirsg=_CreateStringGadget(gfxwin,20,ty,x-30,_NBH+6,LConfig.rdir,256,1,0,1,7,4);
    ty+=_NBH+6+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,x-cw-10,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              tldir=(char*)_allocsafe(strlen(ldirsg->string)+1);
              if(tldir!=NULL) {
                trdir=(char*)_allocsafe(strlen(rdirsg->string)+1);
                if(trdir!=NULL) {
                  strcpy(tldir,ldirsg->string);
                  strcpy(trdir,rdirsg->string);
                  _freesafe(LConfig.ldir);
                  _freesafe(LConfig.rdir);
                  LConfig.ldir=tldir;
                  LConfig.rdir=trdir;
                }
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return;
}

void WCChooseShortkey(unsigned long *key,int *mods)
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  int w;
  w=(strlen(_locale[66])+3)*_CharWidth;
  *key=0;
  gfxwin=_OpenWindow(NULL,0,0,w,_BBH+5,w,w,w,_BBH+5,_BBH+5,_BBH+5,0,_locale[61],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,5+_GlobalGUI.font->ascent,1,_locale[66]);
    _RedrawWin(gfxwin);
    do {
      msg=_WaitMessage(gfxwin);
      if(msg!=NULL) {
        if(msg->type==KeyRelease) {
          if((msg->key!=XK_Shift_L)&&(msg->key!=XK_Shift_R)) {
            *key=msg->key;
            *mods=KEYSTATEMASK(msg->keystate);
            _ReplyMessage(msg);
            break;
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    } while(1);
    _CloseWindow(gfxwin);
  }
  return;
}

int WCChooseUFlag(void)
{
  /* Fertig */
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _ListView *lv;
  _ListViewContent *templvc,*report,*select;
  int x,returnvalue=0,okw,cw;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,500,300,500,500,500,300,300,300,0,_locale[67],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateButton(gfxwin,10,275,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,500-10-cw,275,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    lv=_CreateListView(gfxwin,10,10,480,300-10-_BBH-10,TRUE,FALSE,10,TRUE,FALSE,10,NULL,3);
    templvc=NULL;
    for(x=0;x<UFLAGNR;x++) {
      templvc=_AddListViewContent(lv,templvc,_localeuflags[x],4+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
      templvc->active=FALSE;
    }
    select=NULL;
    _RedrawWin(gfxwin);
    do {
      msg=_WaitMessage(gfxwin);
      if(msg!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              returnvalue=-1;
              templvc=lv->first;
              x=0;
              while(templvc!=NULL) {
                if(templvc->active==TRUE) returnvalue=x;
                templvc=templvc->next;
                x++;
              }
            } else if(tbutton->data==2) {
              returnvalue=-1;
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            report=msg->lv_oneselect;
            if(report!=NULL) {
              if(select!=NULL) {
                select->active=FALSE;
              }
              report->active=TRUE;
              select=report;
              _RedrawWin(gfxwin);
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            returnvalue=-1;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    } while(1);
    _CloseWindow(gfxwin);
  }
  return returnvalue;
}

int WCEditButton(struct _buttondef *changeb)
{
  /* Fertig */
  char tcheck,*ttext,*tusercom,buf1[64],buf2[1024],*textbuf;
  int tfg,tbg,tmods,w,h;
  unsigned long tshortkey;
  long tcomnr,tflag1,tflag2;
  unsigned long newshortkey;
  int mods,returnvalue=0;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *title,*usercomsg;
  _SolidButton *example;
  _Text *shortkeyt;
  _ListView *comlv,*flaglv,*templv;
  _ListViewContent *templvc,*select=NULL,*report,*lvc;
  int x,y,e,okw,cw,ty;

  tcheck=changeb->check;
  tfg=changeb->fg;
  tbg=changeb->bg;
  tshortkey=changeb->shortkey;
  tmods=KEYSTATEMASK(changeb->mods);
  tcomnr=changeb->comnr;
  tflag1=changeb->flag1;
  tflag2=changeb->flag2;
  x=strlen(_locale[60]);
  if(strlen(_locale[65])>x) x=strlen(_locale[65]);
  w=300+x*_CharWidth;
  h=5;
  h+=_NBH+6+5;
  h+=_NBH+10;
  h+=_NBH+5;
  h+=_NBH+5;
  h+=6*_BBH+5;
  h+=_NBH+6+5;
  h+=_BBH+5;
  textbuf=(char*)_allocsafe(1024);
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[59],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[60]);
    title=_CreateStringGadget(gfxwin,20+strlen(_locale[60])*_CharWidth,ty-2,w-30-strlen(_locale[60])*_CharWidth,_NBH+6,changeb->text,256,1,0,1,7,3);
    ty+=_NBH+6+5;
    example=_CreateSolidButton(gfxwin,10,ty,5*_CharWidth,_NBH,tfg,tbg,"Test");
    _CreateButton(gfxwin,20+5*_CharWidth,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",4);
    _CreateButton(gfxwin,20+5*_CharWidth+_CharWidth*(strlen(_locale[32])+2)+10,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",5);
    ty+=_NBH+10;
    x=strlen(_locale[61]);
    if(strlen(_locale[62])>x) x=strlen(_locale[62]);
    _CreateButton(gfxwin,10,ty,(x+3)*_CharWidth,_NBH,_black,0,_locale[61],TRUE,_black,0,_locale[62],6);
    if(tshortkey==0) {
      strcpy(buf2,"");
    } else {
      strcpy(buf1,XKeysymToString(tshortkey));
      strcpy(buf2,"");
      if((tmods&Mod1Mask)==Mod1Mask) strcat(buf2,"Left Alt + ");
      if((tmods&ControlMask)==ControlMask) strcat(buf2,"Control + ");
      if((tmods&ShiftMask)==ShiftMask) strcat(buf2,"Shift + ");
      strcat(buf2,buf1);
    }
    shortkeyt=_CreateText(gfxwin,20+(x+3)*_CharWidth,ty+_GlobalGUI.font->ascent,1,"");
    _freesafe(shortkeyt->text);
    shortkeyt->text=textbuf;
    strcpy(shortkeyt->text,buf2);
    ty+=_NBH+5;
    _CreateText(gfxwin,20,ty+_GlobalGUI.font->ascent,1,_locale[63]);
    _CreateText(gfxwin,10+w/2,ty+_GlobalGUI.font->ascent,1,_locale[64]);
    ty+=_NBH+5;
    comlv=_CreateListView(gfxwin,10,ty,w/2-20,6*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,7);
    templvc=NULL;
    for(x=0;x<COMNR;x++) {
      templvc=_AddListViewContent(comlv,templvc,_localecoms[x],10+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
      if((tcheck!=0)&&(tcomnr==x)) {
        templvc->active=TRUE;
        select=templvc;
      } else {
        templvc->active=FALSE;
      }
    }
    flaglv=_CreateListView(gfxwin,w/2,ty,w/2-20,6*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,8);
    templvc=NULL;
    for(x=0;x<flaginfo[tcomnr][0];x++) {
      templvc=_AddListViewContent(flaglv,templvc,_localeflags[flaginfo[tcomnr][1]+x],10+COMNR+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=2;
      templvc->bg_select=1;
      y=pow(2,x);
      if((tcheck!=0)&&((tflag1&y)==y)) {
        templvc->select=TRUE;
      } else {
        templvc->select=FALSE;
      }
    }
    ty+=6*_BBH+5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[65]);
    usercomsg=_CreateStringGadget(gfxwin,20+strlen(_locale[65])*_CharWidth,ty-2,w-30-strlen(_locale[65])*_CharWidth-20,_NBH+6,changeb->usercom,1024,1,0,1,7,9);
    _CreateButton(gfxwin,20+strlen(_locale[65])*_CharWidth+w-30-strlen(_locale[65])*_CharWidth-20,ty-2,20,_NBH+6,_black,0,"",FALSE,_white,2,"",0);
    ty+=_NBH+6+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              returnvalue=1;
              changeb->check=1;
              changeb->fg=example->fg;
              changeb->bg=example->bg;
              changeb->shortkey=tshortkey;
              changeb->mods=tmods;
              y=0;
              templvc=comlv->first;
              x=0;
              while(templvc!=NULL) {
                if(templvc->active==TRUE) y=x;
                templvc=templvc->next;
                x++;
              }
              changeb->comnr=y;
              templvc=flaglv->first;
              x=0;
              y=0;
              while(templvc!=NULL) {
                if(templvc->select==TRUE) {
                  y=y+pow(2,x);
                }
                templvc=templvc->next;
                x++;
              }
              changeb->flag1=y;
              ttext=(char*)_allocsafe(strlen(title->string)+1);
              if(ttext!=NULL) {
                strcpy(ttext,title->string);
                _freesafe(changeb->text);
                changeb->text=ttext;
              }
              tusercom=(char*)_allocsafe(strlen(usercomsg->string)+1);
              if(tusercom!=NULL) {
                strcpy(tusercom,usercomsg->string);
                _freesafe(changeb->usercom);
                changeb->usercom=tusercom;
              }
            } else if(tbutton->data==0) {
              x=WCChooseUFlag();
              if(x>=0) {
                strcpy(buf1,_UFlags[x]);
                if((strlen(usercomsg->string)+strlen(buf1))<1022) {
                  strncpy(buf2,usercomsg->string,usercomsg->cursor);
                  buf2[usercomsg->cursor]=0;
                  strcat(buf2,buf1);
                  strcat(buf2,(usercomsg->string)+usercomsg->cursor);
                  strcpy(usercomsg->string,buf2);
                  _RedrawWin(gfxwin);
                }
              }
            } else if(tbutton->data==4) {
              x=WCPalette(example->fg);
              if(x>=0) {
                example->fg=x;
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==5) {
              x=WCPalette(example->bg);
              if(x>=0) {
                example->bg=x;
                _RedrawWin(gfxwin);
              }            
            } else if(tbutton->data==6) {
              if(msg->button==Button1) {
                WCChooseShortkey(&newshortkey,&mods);
                if(newshortkey!=0) {
                  tshortkey=newshortkey;
                  tmods=mods;
                  strcpy(buf2,"");
                  if((tmods&Mod1Mask)==Mod1Mask) strcat(buf2,"Left Alt + ");
                  if((tmods&ControlMask)==ControlMask) strcat(buf2,"Control + ");
                  if((tmods&ShiftMask)==ShiftMask) strcat(buf2,"Shift + ");
                  strcat(buf2,XKeysymToString(tshortkey));
                  strcpy(shortkeyt->text,buf2);
                  _RedrawWin(gfxwin);
                }
              } else if(msg->button==Button3) {
                strcpy(shortkeyt->text,"");
                tshortkey=0;
                tmods=0;
                _RedrawWin(gfxwin);
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            templv=msg->gadget;
            if(templv==comlv) {
              report=msg->lv_oneselect;
              if(report!=NULL) {
                if(select!=NULL) {
                  select->active=FALSE;
                }
                report->active=TRUE;
                select=report;
                x=report->data-10;
                lvc=flaglv->first;
                while(lvc!=NULL) {
                  _RemoveListViewContent(gfxwin,flaglv,lvc);
                  lvc=flaglv->first;
                }
                lvc=NULL;
                for(y=0;y<flaginfo[x][0];y++) {
                  lvc=_AddListViewContent(flaglv,lvc,_localeflags[flaginfo[x][1]+y],10+COMNR+y);
                  lvc->fg_normal=1;
                  lvc->bg_normal=0;
                  lvc->fg_select=2;
                  lvc->bg_select=1;
                  e=pow(2,y);
                  if((tcheck!=0)&&((tflag1&e)==e)) {
                    lvc->select=TRUE;
                  } else {
                    lvc->select=FALSE;
                  }
                }
                _RedrawWin(gfxwin);
              }
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return returnvalue;
}

int WCCleanUpButtons(int banksize)
{
  int count=0,maxbank,x;
  bool isempty;
  struct _buttondef *tempb,*tempb2,*last;
  tempb=LConfig.firstbutton;
  while(tempb!=NULL) {
    count++;
    tempb=tempb->next;
  }
  while((count%banksize)!=0) {
    if(_CreateConfigButton(0,"",0,0,0,0,0,0,0,"")!=0) {
      printf("No Memory!!!\n");
      return 1;
    }
    count++;
  }
  /* jetzt existieren ein vielfaches von banksize Buttons
     nun noch die leeren Bnke lschen */
/*  tempb=LConfig.firstbutton;
  count=1;
  while(tempb->next!=NULL) {
    tempb=tempb->next;
    count++;
  }*/
  maxbank=count/banksize;
  while(maxbank>1) {
    /* find maxbank -1 */
    tempb=LConfig.firstbutton;
    count=1;
    while(count<((maxbank-1)*banksize)) {
      tempb=tempb->next;
      count++;
    }
    /* tempb ist der letzte der vorletzten Bank */
    /* ab tempb prfen, ob leer */
    tempb2=tempb->next;
    for(x=0,isempty=TRUE;x<banksize;x++) {
      if(tempb2->check!=0) isempty=FALSE;
      tempb2=tempb2->next;
    }
    if(isempty==TRUE) {
      /* bank lschen */
      last=tempb->next;
      tempb->next=NULL;
      tempb=last;
      for(x=0;x<banksize;x++) {
        tempb2=tempb->next;
	_FreeConfigButton(tempb);
        tempb=tempb2;
      }
      maxbank--;    
    } else {
      break;
    }
  }
  return maxbank;
}

void WCRemapButtons(struct _buttondef *firstbutton,_Button *firstlgfxbutton,_Button *firstrgfxbutton,int bank)
{
  int banksize,x;
  struct _buttondef *tempb;
  _Button *button[2];
  char *tstr;
  
  banksize=LConfig.numxbuttons*LConfig.numybuttons*2;
  tempb=firstbutton;
  for(x=0;x<(bank*banksize);x++) {
    tempb=tempb->next;
  }
  /* ab tempb mappen */
  button[0]=firstlgfxbutton;
  button[1]=firstrgfxbutton;
  while((tempb!=NULL)&&(banksize>0)) {
    for(x=0;x<2;x++) {
      if(tempb->check!=0) {
        button[x]->fg_normal=tempb->fg;
        button[x]->bg_normal=tempb->bg;
        tstr=(char*)_allocsafe(strlen(tempb->text)+1);
        strcpy(tstr,tempb->text);
        _freesafe(button[x]->text_normal);
        button[x]->text_normal=tstr;
      } else {
        button[x]->bg_normal=0;
        tstr=(char*)_allocsafe(1);
        tstr[0]=0;
        _freesafe(button[x]->text_normal);
        button[x]->text_normal=tstr;
      }
      tempb=tempb->next;
      button[x]=button[x]->next;
      banksize--;
    }
  }
}

void WCChangeButtons(void)
{
  /* Fertig */
  struct _buttondef *tempb,*tempb1,*tempb2,*tempb3,*localfirst,*b1=NULL,*b2,swap;
  int x,y,z,mode,count;
  int w,h,iw,bw,offsetl,offsetr,ty,tw;
  char *ttext=NULL,buf1[10],*tstr;
  _Text *bankt;
  int bank,maxbank,banksize;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton,*sourcebutton=NULL,*firstlbutton=NULL,*firstrbutton=NULL;
  _SolidButton *statebar;
  banksize=LConfig.numxbuttons*LConfig.numybuttons*2;
  maxbank=WCCleanUpButtons(banksize);
  /* Buttons angepat */
  tempb=LConfig.firstbutton;
  localfirst=_DuplicateConfigButton(tempb);
  if(localfirst==NULL) {
    printf("No Memory!!!\n");
    return;
  }
  tempb1=localfirst;
  tempb=tempb->next;
  while(tempb!=NULL) {
    tempb1->next=_DuplicateConfigButton(tempb);
    tempb1=tempb1->next;
    tempb=tempb->next;
  }
  /* lokale Kopie angefertigt */
  /* Fenster ffnen mit: festgesetze Anzahl Buttons fr linke Maustaste oben
                         festgesetze Anzahl Buttons fr rechte Maustaste unten
                         Button "Button kopieren"
                         Button "Button vertauschen"
                         Button "Button lschen"
                         Button "Ok"
                         Button "Cancel"
  */
  w=720;
  h=10+2*_NBH+LConfig.numybuttons*_BBH*2+15+10+2*_BBH+20+_BBH+10;
  mode=0;
  bank=0;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[4],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    z=LConfig.numybuttons*_BBH+_NBH+10;
    _CreateBevelBox(gfxwin,10,ty,w-20,z,HIGH);
    ty+=5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[51]);
    ty+=_NBH;
    iw=w-30;
    tempb=localfirst;
    bw=iw/LConfig.numxbuttons;
    offsetl=6;
    for(y=0;y<LConfig.numybuttons;y++) {
      for(x=0;x<LConfig.numxbuttons;x++) {
        tbutton=_CreateButton(gfxwin,15+x*bw,ty+y*_BBH,bw,_BBH,tempb->fg,tempb->bg,tempb->text,FALSE,_white,2,"",offsetl+y*LConfig.numxbuttons+x);
        if((y+x)==0) {
          firstlbutton=tbutton;
        }
        tempb=tempb->next->next;
      }
    }
    ty+=LConfig.numybuttons*_BBH+5+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,z,HIGH);
    ty+=5;
    _CreateText(gfxwin,15,ty+_GlobalGUI.font->ascent,1,_locale[52]);
    ty+=_NBH;
    offsetr=offsetl+LConfig.numxbuttons*LConfig.numybuttons;
    tempb=localfirst->next;
    for(y=0;y<LConfig.numybuttons;y++) {
      for(x=0;x<LConfig.numxbuttons;x++) {
        tbutton=_CreateButton(gfxwin,15+x*bw,ty+y*_BBH,bw,_BBH,tempb->fg,tempb->bg,tempb->text,FALSE,_white,2,"",offsetr+y*LConfig.numxbuttons+x);
        if((y+x)==0) {
          firstrbutton=tbutton;
        }
        if(tempb->next!=NULL) tempb=tempb->next->next;
      }
    }
    ty+=LConfig.numybuttons*_BBH+5+5;
    
    sprintf(buf1,"%d",bank);
    ttext=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
    strcpy(ttext,_locale[68]);
    strcat(ttext," ");
    strcat(ttext,buf1);
    bankt=_CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,ttext);
    _freesafe(ttext);
    x=10+TextWidth(_locale[68],strlen(_locale[68]))+3*_CharWidth+10;
    tw=TextWidth(_locale[69],strlen(_locale[69]))+10;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[69],FALSE,_white,2,"",-1);
    x+=tw+10;
    tw=TextWidth(_locale[70],strlen(_locale[70]))+10;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[70],FALSE,_white,2,"",-2);
    x+=tw+10;
    tw=TextWidth(_locale[71],strlen(_locale[71]))+10;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[71],FALSE,_white,2,"",-3);
    x+=tw+10;
    tw=TextWidth(_locale[72],strlen(_locale[72]))+10;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[72],FALSE,_white,2,"",-4);
    ty+=_BBH+5;    
    statebar=_CreateSolidButton(gfxwin,10,ty,w-20,_BBH,2,3,_locale[53]);
    ty+=_BBH+5;
    _CreateBevelBox(gfxwin,10,ty,w-20,_BBH+10,HIGH);
    ty+=5;
    y=w-40;
    _CreateButton(gfxwin,20+y*3/5,ty,y/5,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,20+y*4/5,ty,y/5,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _CreateButton(gfxwin,20,ty,y/5,_BBH,_black,0,_locale[48],FALSE,_white,2,"",3);
    _CreateButton(gfxwin,20+y*1/5,ty,y/5,_BBH,_black,0,_locale[49],FALSE,_white,2,"",4);
    _CreateButton(gfxwin,20+y*2/5,ty,y/5,_BBH,_black,0,_locale[50],FALSE,_white,2,"",5);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data>=offsetl) {
              tempb=localfirst;
              for(x=0;x<(bank*banksize);x++) {
                tempb=tempb->next;
              }
              x=tbutton->data;
              if((x-offsetr)<0) {
                y=x-offsetl;
                for(z=0;z<y;z++) {
                  tempb=tempb->next->next;
                }
              } else {
                y=x-offsetr;
                tempb=tempb->next;
                for(z=0;z<y;z++) {
                  tempb=tempb->next->next;
                }
              }
            }
	    if(tbutton->data==-1) {
              if((bank+1)<maxbank) {
                bank++;
                WCRemapButtons(localfirst,firstlbutton,firstrbutton,bank);
                sprintf(buf1,"%d",bank);
                tstr=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                strcpy(tstr,_locale[68]);
                strcat(tstr," ");
                strcat(tstr,buf1);
                _freesafe(bankt->text);
                bankt->text=tstr;
                _RedrawWin(gfxwin);
              }
	    } else if(tbutton->data==-2) {
              if(bank>0) {
                bank--;
                WCRemapButtons(localfirst,firstlbutton,firstrbutton,bank);
                sprintf(buf1,"%d",bank);
                tstr=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                strcpy(tstr,_locale[68]);
                strcat(tstr," ");
                strcat(tstr,buf1);
                _freesafe(bankt->text);
                bankt->text=tstr;
                _RedrawWin(gfxwin);
              }
	    }
            if(mode==0) {
              if(tbutton->data==1) {
                tempb=LConfig.firstbutton;
                LConfig.firstbutton=localfirst;
                while(tempb!=NULL) {
                  tempb1=tempb->next;
                  _FreeConfigButton(tempb);
                  tempb=tempb1;
                }
                WCCleanUpButtons(banksize);
              } else if(tbutton->data==2) {
                tempb=localfirst;
                while(tempb!=NULL) {
                  tempb1=tempb->next;
                  _FreeConfigButton(tempb);
                  tempb=tempb1;
                }
              } else if(tbutton->data==3) {
                ttext=statebar->text;
                statebar->text=_locale[54];
                _RedrawWin(gfxwin);
                mode=1;
              } else if(tbutton->data==4) {
                ttext=statebar->text;
                statebar->text=_locale[56];
                _RedrawWin(gfxwin);
                mode=3;
              } else if(tbutton->data==5) {
                ttext=statebar->text;
                statebar->text=_locale[58];
                _RedrawWin(gfxwin);
                mode=5;
	      } else if(tbutton->data==-4) {
                /* aktuelle lschen */
                if(maxbank>1) {
                  tempb=localfirst;
                  count=1;
                  while(count<(bank*banksize)) {
                    tempb=tempb->next;
                    count++;
                  }
                  /* tempb ist der letzte der vorherigen Bank */
                  if(bank==0) {
                    tempb2=tempb;
                  } else {
                    tempb2=tempb->next;
                  }
                  for(count=0;count<banksize;count++) {
                    tempb3=tempb2->next;
                    _FreeConfigButton(tempb2);
                    tempb2=tempb3;
                  }
                  if(bank==0) {
                    localfirst=tempb2;
                  } else {
                    tempb->next=tempb2;
                  }
                  maxbank--;
                  if(bank==maxbank) bank--;
                  WCRemapButtons(localfirst,firstlbutton,firstrbutton,bank);
                  sprintf(buf1,"%d",bank);
                  tstr=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                  strcpy(tstr,_locale[68]);
                  strcat(tstr," ");
                  strcat(tstr,buf1);
                  _freesafe(bankt->text);
                  bankt->text=tstr;
                  _RedrawWin(gfxwin);
                }
	      } else if(tbutton->data==-3) {
                /* hinter der aktuellen eine neue bank anfgen */
                tempb=localfirst;
                count=1;
                while(count<((bank+1)*banksize)) {
                  tempb=tempb->next;
                  count++;
                }
                tempb1=tempb->next;
                /* zwischen tempb und tempb1 anfgen */
                for(count=0;count<banksize;count++) {
                  tempb2=_CreateNewConfigButton(0,"",0,0,0,0,0,0,0,"");
                  tempb->next=tempb2;
                  tempb=tempb->next;
                }
                tempb->next=tempb1;
                maxbank++;
                bank++;
                WCRemapButtons(localfirst,firstlbutton,firstrbutton,bank);
                sprintf(buf1,"%d",bank);
                tstr=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                strcpy(tstr,_locale[68]);
                strcat(tstr," ");
                strcat(tstr,buf1);
                _freesafe(bankt->text);
                bankt->text=tstr;
                _RedrawWin(gfxwin);
              } else if(tbutton->data>=offsetl) {
                if(WCEditButton(tempb)!=0) {
                  tbutton->fg_normal=tempb->fg;
                  tbutton->bg_normal=tempb->bg;
                  ttext=(char*)_allocsafe(strlen(tempb->text)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,tempb->text);
                    _freesafe(tbutton->text_normal);
                    tbutton->text_normal=ttext;
                  }
                  _RedrawWin(gfxwin);
                }
              }
              if((tbutton->data==1)||(tbutton->data==2)) {
                _ReplyMessage(msg);
                break;
              }
            } else if(mode==1) {
              if(tbutton->data>=offsetl) {
                b1=tempb;
                statebar->text=_locale[55];
                _RedrawWin(gfxwin);
                mode=2;
              }
            } else if(mode==2) {
              if(tbutton->data>=offsetl) {
                b2=tempb;
                statebar->text=ttext;
                mode=0;
                /* b1 nach b2 */
                if(b1!=b2) {
                  b2->check=b1->check;
                  b2->fg=b1->fg;
                  b2->bg=b1->bg;
                  b2->shortkey=b1->shortkey;
                  b2->mods=b1->mods;
                  b2->comnr=b1->comnr;
                  b2->flag1=b1->flag1;
                  b2->flag2=b1->flag2;
                  ttext=(char*)_allocsafe(strlen(b1->text)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,b1->text);
                    _freesafe(b2->text);
                    b2->text=ttext;
                  }
                  ttext=(char*)_allocsafe(strlen(b1->usercom)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,b1->usercom);
                    _freesafe(b2->usercom);
                    b2->usercom=ttext;
                  }
                  tbutton->fg_normal=b2->fg;
                  tbutton->bg_normal=b2->bg;
                  ttext=(char*)_allocsafe(strlen(b1->text)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,b1->text);
                    _freesafe(tbutton->text_normal);
                    tbutton->text_normal=ttext;
                  }
                }
                _RedrawWin(gfxwin);
              }
            } else if(mode==3) {
              if(tbutton->data>=offsetl) {
                b1=tempb;
                sourcebutton=tbutton;
                statebar->text=_locale[57];
                _RedrawWin(gfxwin);
                mode=4;
              }
            } else if(mode==4) {
              if(tbutton->data>=offsetl) {
                b2=tempb;
                statebar->text=ttext;
                mode=0;
                /* b1 <-> b2 */
                if(b1!=b2) {
                  swap.check=b2->check;
                  swap.fg=b2->fg;
                  swap.bg=b2->bg;
                  swap.shortkey=b2->shortkey;
                  swap.mods=b2->mods;
                  swap.comnr=b2->comnr;
                  swap.flag1=b2->flag1;
                  swap.flag2=b2->flag2;
                  swap.text=b2->text;
                  swap.usercom=b2->usercom;
                  b2->check=b1->check;
                  b2->fg=b1->fg;
                  b2->bg=b1->bg;
                  b2->shortkey=b1->shortkey;
                  b2->mods=b1->mods;
                  b2->comnr=b1->comnr;
                  b2->flag1=b1->flag1;
                  b2->flag2=b1->flag2;
                  b2->text=b1->text;
                  b2->usercom=b1->usercom;
                  b1->check=swap.check;
                  b1->fg=swap.fg;
                  b1->bg=swap.bg;
                  b1->shortkey=swap.shortkey;
                  b1->mods=swap.mods;
                  b1->comnr=swap.comnr;
                  b1->flag1=swap.flag1;
                  b1->flag2=swap.flag2;
                  b1->text=swap.text;
                  b1->usercom=swap.usercom;
                  WCRemapButtons(localfirst,firstlbutton,firstrbutton,bank);
                }
                _RedrawWin(gfxwin);
              }
            } else if(mode==5) {
              if(tbutton->data>=offsetl) {
                b1=tempb;
                statebar->text=ttext;
                mode=0;
                /* del b1 */
                b1->check=0;
                b1->fg=0;
                b1->bg=0;
                b1->shortkey=0;
                b1->mods=0;
                b1->comnr=0;
                b1->flag1=0;
                b1->flag2=0;
                ttext=(char*)_allocsafe(1);
                if(ttext!=NULL) {
                  ttext[0]=0;
                  _freesafe(b1->text);
                  b1->text=ttext;
                }
                ttext=(char*)_allocsafe(1);
                if(ttext!=NULL) {
                  ttext[0]=0;
                  _freesafe(b1->usercom);
                  b1->usercom=ttext;
                }
                tbutton->fg_normal=b1->fg;
                tbutton->bg_normal=b1->bg;
                ttext=(char*)_allocsafe(strlen(b1->text)+1);
                if(ttext!=NULL) {
                  strcpy(ttext,b1->text);
                  _freesafe(tbutton->text_normal);
                  tbutton->text_normal=ttext;
                }
                _RedrawWin(gfxwin);
              }
            }
          }
        } else if(msg->type==KeyRelease) {
          if(msg->key==XK_Escape) {
            if(mode!=0) {
              statebar->text=ttext;
              _RedrawWin(gfxwin);
              mode=0;
            }
          }
        } else if(msg->type==ClientMessage) {
          if((msg->gadgettype==CLOSE_GADGET)&&(mode==0)) {
            tempb=localfirst;
            while(tempb!=NULL) {
              tempb1=tempb->next;
              _FreeConfigButton(tempb);
              tempb=tempb1;
            }
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return;
}

void WCCleanUpPath(struct _pathdef *first,int base)
{
  /* Wichtig ist, da es vielfache von base Eintrge gibt */
  struct _pathdef *tempp1,*tempp2,*last,*prev;
  int x,y;
  tempp1=first;
  x=1;
  while(tempp1->next!=NULL) {
    tempp1=tempp1->next;
    x++;
  }
  last=tempp1;
  if(x>base) {
    tempp1=last;
    y=0;
    while(tempp1!=NULL) {
      prev=tempp1->prev;
      if(tempp1->check==0) {
        y++;
        if(y==base) {
          if((x-base)>=base) {
            tempp1->prev->next=NULL;
            x-=base;
            last=tempp1->prev;
            while(tempp1!=NULL) {
              tempp2=tempp1->next;
              _FreeConfigPath(tempp1);
              tempp1=tempp2;
            }
          } else break;
          y=0;
        }
      } else {
        break;
      }
      tempp1=prev;
    }
  }
}

void WCUpdatePaths(_Button *pathb[],struct _pathdef *first,int bank)
{
  struct _pathdef *t1;
  int x,y;
  char *tstr1;
  t1=first;
  for(x=0;x<bank;x++) {
    for(y=0;y<LConfig.numybuttons;y++) {
      t1=t1->next;
    }
  }
  for(y=0;y<LConfig.numybuttons;y++) {
    if(t1->check==0) {
      pathb[y]->fg_normal=0;
      pathb[y]->bg_normal=0;
      tstr1=(char*)_allocsafe(1);
      if(tstr1!=NULL) {
        tstr1[0]=0;
        _freesafe(pathb[y]->text_normal);
        pathb[y]->text_normal=tstr1;
      }
    } else {
      pathb[y]->fg_normal=t1->fg;
      pathb[y]->bg_normal=t1->bg;
      tstr1=(char*)_allocsafe(strlen(t1->text)+1);
      if(tstr1!=NULL) {
        strcpy(tstr1,t1->text);
        _freesafe(pathb[y]->text_normal);
        pathb[y]->text_normal=tstr1;
      }
    }
    t1=t1->next;
  }
}

int WCEditPath(struct _pathdef *changep)
{
  /* Fertig */
  char tcheck,*ttext,*tpath,buf1[64],buf2[1024],*textbuf;
  int tfg,tbg,tmods,w,h;
  unsigned long tshortkey;
  unsigned long newshortkey;
  int mods,returnvalue=0;
  int sizeindex[5];
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *title,*pathsg;
  _SolidButton *example;
  _Text *shortkeyt;
  int x,y,okw,cw,ty;
  tcheck=changep->check;
  tfg=changep->fg;
  tbg=changep->bg;
  tshortkey=changep->shortkey;
  tmods=KEYSTATEMASK(changep->mods);
  sizeindex[0]=(strlen(_locale[83])+1+8)*_CharWidth;
  sizeindex[1]=50+_CharWidth*(strlen(_locale[32])+2)+_CharWidth*(strlen(_locale[33])+2)+20;
  sizeindex[2]=(strlen(_locale[61])+2+23+10)*_CharWidth;
  sizeindex[3]=(strlen(_locale[62])+2+23+10)*_CharWidth;
  sizeindex[4]=(strlen(_locale[84])+1+8)*_CharWidth;
  x=0;
  for(y=1;y<5;y++) {
    if(sizeindex[y]>sizeindex[x]) x=y;
  }
  w=sizeindex[x]+20;
  h=5;
  h+=_NBH+6+5;
  h+=_NBH+10;
  h+=_NBH+10;
  h+=_NBH+6+5;
  h+=_BBH+5;
  textbuf=(char*)_allocsafe(1024);
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[82],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[83]);
    title=_CreateStringGadget(gfxwin,20+strlen(_locale[83])*_CharWidth,ty-2,w-30-strlen(_locale[83])*_CharWidth,_NBH+6,changep->text,256,1,0,1,7,3);
    ty+=_NBH+6+5;
    example=_CreateSolidButton(gfxwin,10,ty,5*_CharWidth,_NBH,tfg,tbg,"Test");
    _CreateButton(gfxwin,5*_CharWidth+20,ty,_CharWidth*(strlen(_locale[32])+2),_NBH,_black,0,_locale[32],FALSE,_white,2,"",4);
    _CreateButton(gfxwin,5*_CharWidth+20+_CharWidth*(strlen(_locale[32])+2)+10,ty,_CharWidth*(strlen(_locale[33])+2),_NBH,_black,0,_locale[33],FALSE,_white,2,"",5);
    ty+=_NBH+10;
    x=strlen(_locale[61]);
    if(strlen(_locale[62])>x) x=strlen(_locale[62]);
    _CreateButton(gfxwin,10,ty,(x+3)*_CharWidth,_NBH,_black,0,_locale[61],TRUE,_black,0,_locale[62],6);
    if(tshortkey==0) {
      strcpy(buf2,"");
    } else {
      strcpy(buf1,XKeysymToString(tshortkey));
      strcpy(buf2,"");
      if((tmods&Mod1Mask)==Mod1Mask) strcat(buf2,"Left Alt + ");
      if((tmods&ControlMask)==ControlMask) strcat(buf2,"Control + ");
      if((tmods&ShiftMask)==ShiftMask) strcat(buf2,"Shift + ");
      strcat(buf2,buf1);
    }
    shortkeyt=_CreateText(gfxwin,20+(x+3)*_CharWidth,ty+_GlobalGUI.font->ascent,1,"");
    _freesafe(shortkeyt->text);
    shortkeyt->text=textbuf;
    strcpy(shortkeyt->text,buf2);
    ty+=_NBH+10;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[84]);
    pathsg=_CreateStringGadget(gfxwin,20+strlen(_locale[84])*_CharWidth,ty-2,w-30-strlen(_locale[84])*_CharWidth-20,_NBH+6,changep->path,1024,1,0,1,7,7);
    ty+=_NBH+6+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              returnvalue=1;
              changep->check=1;
              changep->fg=example->fg;
              changep->bg=example->bg;
              changep->shortkey=tshortkey;
              changep->mods=tmods;
              ttext=(char*)_allocsafe(strlen(title->string)+1);
              if(ttext!=NULL) {
                strcpy(ttext,title->string);
                _freesafe(changep->text);
                changep->text=ttext;
              }
              tpath=(char*)_allocsafe(strlen(pathsg->string)+1);
              if(tpath!=NULL) {
                strcpy(tpath,pathsg->string);
                _freesafe(changep->path);
                changep->path=tpath;
              }
            } else if(tbutton->data==4) {
              x=WCPalette(example->fg);
              if(x>=0) {
                example->fg=x;
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==5) {
              x=WCPalette(example->bg);
              if(x>=0) {
                example->bg=x;
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==6) {
              if(msg->button==Button1) {
                WCChooseShortkey(&newshortkey,&mods);
                if(newshortkey!=0) {
                  tshortkey=newshortkey;
                  tmods=mods;
                  strcpy(buf2,"");
                  if((tmods&Mod1Mask)==Mod1Mask) strcat(buf2,"Left Alt + ");
                  if((tmods&ControlMask)==ControlMask) strcat(buf2,"Control + ");
                  if((tmods&ShiftMask)==ShiftMask) strcat(buf2,"Shift + ");
                  strcat(buf2,XKeysymToString(tshortkey));
                  strcpy(shortkeyt->text,buf2);
                  _RedrawWin(gfxwin);
                }
              } else if(msg->button==Button3) {
                strcpy(shortkeyt->text,"");
                tshortkey=0;
                tmods=0;
                _RedrawWin(gfxwin);
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return returnvalue;
}

void WCChangePath()
{
  /* Fertig */
  /* Zuerst Path anpassen: mu vielfaches von numybuttons sein
     bei zu vielen nur von hinten Bank-Weise lschen */
  struct _pathdef *tempp,*tempp1,*localfirst,*last=NULL,*tempp2,*tempp3,*source=NULL,swap;
  int x,y,z,mode,w,h,tw,bank,maxbank,pw;
  int sizeindex[12],maxindex;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton,*pathb[10];
  _SolidButton *statebar;
  _Text *bankt;
  char *ttext,buf1[10],*statetext=NULL;
  int okw,cw,ty,ty2;
  x=1;
  tempp=LConfig.firstpath;
  while(tempp->next!=NULL) {
    tempp=tempp->next;
    x++;
  }
  y=x%LConfig.numybuttons;
  if(y>0) {
    for(z=y;z<LConfig.numybuttons;z++) {
      if(_CreateConfigPath(0,"",0,0,0,0,"")!=0) return;
    }
  }
  /* Nun existieren vielfache von numybuttons Def. */
  WCCleanUpPath(LConfig.firstpath,LConfig.numybuttons);
  /* Die Liste enthlt nun nur soviele Bnke wie bentigt werden */
  /* lokale Kopie anfertigen */
  tempp=LConfig.firstpath;
  localfirst=_DuplicateConfigPath(tempp);
  if(localfirst==NULL) {
    printf("No Memory!!!\n");
    return;
  }
  tempp1=localfirst;
  tempp=tempp->next;
  x=1;
  while(tempp!=NULL) {
    tempp1->next=_DuplicateConfigPath(tempp);
    tempp1->next->prev=tempp1;
    tempp1=tempp1->next;
    tempp=tempp->next;
    x++;
  }
  /* lokale Kopie angefertigt */
  mode=0;
  bank=0;
  maxbank=x/LConfig.numybuttons;
  sizeindex[0]=(1+10+1)*_CharWidth+10+(strlen(_locale[68])+1+2+1)*_CharWidth;
  sizeindex[1]=(1+10+1)*_CharWidth+10+(strlen(_locale[69])+2)*_CharWidth;
  sizeindex[2]=(1+10+1)*_CharWidth+10+(strlen(_locale[70])+2)*_CharWidth;
  sizeindex[3]=(1+10+1)*_CharWidth+10+(strlen(_locale[71])+2)*_CharWidth;
  sizeindex[4]=(1+10+1)*_CharWidth+10+(strlen(_locale[72])+2)*_CharWidth;
  sizeindex[5]=(strlen(_locale[73])+strlen(_locale[74])+strlen(_locale[75])+6)*_CharWidth;
  sizeindex[6]=(strlen(_locale[76])+2)*_CharWidth;
  sizeindex[7]=(strlen(_locale[77])+2)*_CharWidth;
  sizeindex[8]=(strlen(_locale[78])+2)*_CharWidth;
  sizeindex[9]=(strlen(_locale[79])+2)*_CharWidth;
  sizeindex[10]=(strlen(_locale[80])+2)*_CharWidth;
  sizeindex[11]=(strlen(_locale[81])+2)*_CharWidth;
  maxindex=0;
  for(x=1;x<12;x++) {
    if(sizeindex[x]>sizeindex[maxindex]) maxindex=x;
  }
  w=10+10+sizeindex[maxindex];
  h=5*_BBH;
  if(LConfig.numybuttons>5) h=LConfig.numybuttons*_BBH;
  h+=3*_BBH+5+5+5+5+5;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[5],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    maxindex=0;
    for(x=1;x<5;x++) {
      if(sizeindex[x]>sizeindex[maxindex]) maxindex=x;
    }
    tw=sizeindex[maxindex]-12*_CharWidth-10;
    sprintf(buf1,"%d",bank);
    ttext=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
    strcpy(ttext,_locale[68]);
    strcat(ttext," ");
    strcat(ttext,buf1);
    bankt=_CreateText(gfxwin,w-10-tw,ty+_GlobalGUI.font->ascent,1,ttext);
    _freesafe(ttext);
    ty+=_BBH;
    _CreateButton(gfxwin,w-10-tw,ty,tw,_BBH,_black,0,_locale[69],FALSE,_white,2,"",6);
    ty+=_BBH;
    _CreateButton(gfxwin,w-10-tw,ty,tw,_BBH,_black,0,_locale[70],FALSE,_white,2,"",7);
    ty+=_BBH;
    _CreateButton(gfxwin,w-10-tw,ty,tw,_BBH,_black,0,_locale[71],FALSE,_white,2,"",8);
    ty+=_BBH;
    _CreateButton(gfxwin,w-10-tw,ty,tw,_BBH,_black,0,_locale[72],FALSE,_white,2,"",9);
    ty2=ty+_BBH;
    ty=5;
    pw=w-20-10-tw;
    for(x=0;x<LConfig.numybuttons;x++) {
      pathb[x]=_CreateButton(gfxwin,10,ty,pw,_BBH,_black,0,"",FALSE,_white,2,"",10+x);
      ty+=_BBH;
    }
    if(ty2>ty) ty=ty2;
    ty+=5;
    tw=w-20;
    tw=tw/3;
    _CreateButton(gfxwin,10,ty,tw,_BBH,_black,0,_locale[73],FALSE,_white,2,"",3);
    _CreateButton(gfxwin,10+tw,ty,tw,_BBH,_black,0,_locale[74],FALSE,_white,2,"",4);
    _CreateButton(gfxwin,10+tw+tw,ty,tw,_BBH,_black,0,_locale[75],FALSE,_white,2,"",5);
    ty+=_BBH+5;
    statebar=_CreateSolidButton(gfxwin,10,ty,w-20,_BBH,2,3,_locale[76]);
    ty+=_BBH+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    WCUpdatePaths(pathb,localfirst,bank);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            /* Vorbestimmung des Pfad-Buttons */
            if(tbutton->data>9) {
              x=tbutton->data-10;
              tempp=localfirst;
              for(y=0;y<bank;y++) {
                for(z=0;z<LConfig.numybuttons;z++) {
                  tempp=tempp->next;
                }
              }
              for(y=0;y<x;y++) {
                tempp=tempp->next;
              }
              last=tempp;
            }
            if(tbutton->data==6) {
              if(bank<(maxbank-1)) {
                bank++;
                WCUpdatePaths(pathb,localfirst,bank);
                sprintf(buf1,"%d",bank);
                ttext=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                if(ttext!=NULL) {
                  strcpy(ttext,_locale[68]);
                  strcat(ttext," ");
                  strcat(ttext,buf1);
                  _freesafe(bankt->text);
                  bankt->text=ttext;
                }
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==7) {
              if(bank>0) {
                bank--;
                WCUpdatePaths(pathb,localfirst,bank);
                sprintf(buf1,"%d",bank);
                ttext=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                if(ttext!=NULL) {
                  strcpy(ttext,_locale[68]);
                  strcat(ttext," ");
                  strcat(ttext,buf1);
                  _freesafe(bankt->text);
                  bankt->text=ttext;
                }
                _RedrawWin(gfxwin);
              }
            }
            if(mode==0) {
              if(tbutton->data==1) {
                /* localfirst -> LConfig.firstpath */
                tempp=LConfig.firstpath;
                LConfig.firstpath=localfirst;
                WCCleanUpPath(LConfig.firstpath,LConfig.numybuttons);
              } else if(tbutton->data==2) {
                /* localfirst freilassen */
                tempp=localfirst;
              } else if(tbutton->data==3) {
                statetext=statebar->text;
                statebar->text=_locale[77];
                _RedrawWin(gfxwin);
                mode=1;
              } else if(tbutton->data==4) {
                statetext=statebar->text;
                statebar->text=_locale[79];
                _RedrawWin(gfxwin);
                mode=3;
              } else if(tbutton->data==5) {
                statetext=statebar->text;
                statebar->text=_locale[81];
                _RedrawWin(gfxwin);
                mode=5;              
              } else if(tbutton->data==8) {
                tempp=NULL;
                for(x=0;x<LConfig.numybuttons;x++) {
                  if(tempp==NULL) {
                    tempp=_CreateNewConfigPath(0,"",0,0,0,0,"");
                    tempp1=tempp;
                  } else {
                    tempp->next=_CreateNewConfigPath(0,"",0,0,0,0,"");
                    tempp->next->prev=tempp;
                    tempp=tempp->next;
                  }
                }
                maxbank++;
                tempp2=localfirst;
                for(y=0;y<bank;y++) {
                  for(z=0;z<LConfig.numybuttons;z++) {
                    tempp2=tempp2->next;
                  }
                }
                for(y=1;y<LConfig.numybuttons;y++) {
                  tempp2=tempp2->next;
                }
                tempp3=tempp2->next;
                /* neue Bank zwischen tempp2 und tempp3 einfgen */
                tempp1->prev=tempp2;
                tempp2->next=tempp1;
                if(tempp3!=NULL) {
                  tempp->next=tempp3;
                  tempp3->prev=tempp;
                }
                bank++;
                WCUpdatePaths(pathb,localfirst,bank);
                sprintf(buf1,"%d",bank);
                ttext=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                if(ttext!=NULL) {
                  strcpy(ttext,_locale[68]);
                  strcat(ttext," ");
                  strcat(ttext,buf1);
                  _freesafe(bankt->text);
                  bankt->text=ttext;
                }
                _RedrawWin(gfxwin);
              } else if(tbutton->data==9) {
                if(maxbank>1) {
                  tempp2=localfirst;
                  for(y=0;y<bank;y++) {
                    for(z=0;z<LConfig.numybuttons;z++) {
                      tempp2=tempp2->next;
                    }
                  }
                  tempp3=tempp2;
                  for(y=1;y<LConfig.numybuttons;y++) {
                    tempp3=tempp3->next;
                  }
                  /* Bank beginnend mit tempp2 und endent mit tempp3 entfernen */
                  if(bank==(maxbank-1)) {
                    tempp2->prev->next=NULL;
                    bank--;
                  } else {
                    if(tempp2->prev==NULL) {
                      localfirst=tempp3->next;
                    } else {
                      tempp2->prev->next=tempp3->next;
                    }
                    tempp3->next->prev=tempp2->prev;
                  }
                  maxbank--;
                  for(y=0;y<LConfig.numybuttons;y++) {
                    tempp3=tempp2->next;
                    _FreeConfigPath(tempp2);
                    tempp2=tempp3;
                  }
                  WCUpdatePaths(pathb,localfirst,bank);
                  sprintf(buf1,"%d",bank);
                  ttext=(char*)_allocsafe(strlen(_locale[68])+strlen(buf1)+2);
                  if(ttext!=NULL) {
                    strcpy(ttext,_locale[68]);
                    strcat(ttext," ");
                    strcat(ttext,buf1);
                    _freesafe(bankt->text);
                    bankt->text=ttext;
                  }
                  _RedrawWin(gfxwin);
                }
              } else if(tbutton->data>9) {
                if(WCEditPath(last)!=0) {
                  tbutton->fg_normal=last->fg;
                  tbutton->bg_normal=last->bg;
                  ttext=(char*)_allocsafe(strlen(last->text)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,last->text);
                    _freesafe(tbutton->text_normal);
                    tbutton->text_normal=ttext;
                  }
                  _RedrawWin(gfxwin);
                }
              }
              if((tbutton->data==1)||(tbutton->data==2)) {
                while(tempp!=NULL) {
                  tempp2=tempp->next;
                  _FreeConfigPath(tempp);
                  tempp=tempp2;
                }
                _ReplyMessage(msg);
                break;
              }
            } else if(mode==1) {
              if(tbutton->data>9) {
                source=last;
                statebar->text=_locale[78];
                _RedrawWin(gfxwin);
                mode=2;
              }
            } else if(mode==2) {
              if(tbutton->data>9) {
                /* source nach last kopieren */
                if(source!=last) {
                  last->check=source->check;
                  last->fg=source->fg;
                  last->bg=source->bg;
                  last->shortkey=source->shortkey;
                  last->mods=source->mods;
                  ttext=(char*)_allocsafe(strlen(source->text)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,source->text);
                    _freesafe(last->text);
                    last->text=ttext;
                  }
                  ttext=(char*)_allocsafe(strlen(source->path)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,source->path);
                    _freesafe(last->path);
                    last->path=ttext;
                  }
                  tbutton->fg_normal=last->fg;
                  tbutton->bg_normal=last->bg;
                  ttext=(char*)_allocsafe(strlen(last->text)+1);
                  if(ttext!=NULL) {
                    strcpy(ttext,last->text);
                    _freesafe(tbutton->text_normal);
                    tbutton->text_normal=ttext;
                  }
                }
                statebar->text=statetext;
                mode=0;
                _RedrawWin(gfxwin);                
              }
            } else if(mode==3) {
              if(tbutton->data>9) {
                source=last;
                statebar->text=_locale[80];
                _RedrawWin(gfxwin);
                mode=4;
              }            
            } else if(mode==4) {
              if(tbutton->data>9) {
                statebar->text=statetext;
                mode=0;
                /* source <-> last */
                if(source!=last) {
                  swap.check=last->check;
                  swap.fg=last->fg;
                  swap.bg=last->bg;
                  swap.shortkey=last->shortkey;
                  swap.mods=last->mods;
                  swap.text=last->text;
                  swap.path=last->path;
                  last->check=source->check;
                  last->fg=source->fg;
                  last->bg=source->bg;
                  last->shortkey=source->shortkey;
                  last->mods=source->mods;
                  last->text=source->text;
                  last->path=source->path;
                  source->check=swap.check;
                  source->fg=swap.fg;
                  source->bg=swap.bg;
                  source->shortkey=swap.shortkey;
                  source->mods=swap.mods;
                  source->text=swap.text;
                  source->path=swap.path;
                  WCUpdatePaths(pathb,localfirst,bank);
                }
                _RedrawWin(gfxwin);
              }
            } else if(mode==5) {
              if(tbutton->data>9) {
                statebar->text=statetext;
                mode=0;
                /* del last */
                last->check=0;
                last->fg=0;
                last->bg=0;
                last->shortkey=0;
                last->mods=0;
                ttext=(char*)_allocsafe(1);
                if(ttext!=NULL) {
                  ttext[0]=0;
                  _freesafe(last->text);
                  last->text=ttext;
                }
                ttext=(char*)_allocsafe(1);
                if(ttext!=NULL) {
                  ttext[0]=0;
                  _freesafe(last->path);
                  last->path=ttext;
                }
                tbutton->fg_normal=last->fg;
                tbutton->bg_normal=last->bg;
                ttext=(char*)_allocsafe(strlen(last->text)+1);
                if(ttext!=NULL) {
                  strcpy(ttext,last->text);
                  _freesafe(tbutton->text_normal);
                  tbutton->text_normal=ttext;
                }
                _RedrawWin(gfxwin);
              }
            }
          }
        } else if(msg->type==KeyRelease) {
          if(msg->key==XK_Escape) {
            if(mode!=0) {
              statebar->text=statetext;
              _RedrawWin(gfxwin);
              mode=0;
            }
          }
        } else if(msg->type==ClientMessage) {
          if((msg->gadgettype==CLOSE_GADGET)&&(mode==0)) {
            /* localfirst freilassen */
            tempp=localfirst;
            while(tempp!=NULL) {
              tempp2=tempp->next;
              _FreeConfigPath(tempp);
              tempp=tempp2;
            }
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return;
}

int WCEditByte(int def)
{
  /* Fertig */
  int w,h,x,returncode=-1,tcode;
  char buf1[1024];
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _Text *text;
  _StringGadget *codesg;
  int okw,cw,ty;
  h=5;
  h+=_NBH+5;
  h+=_NBH+6+5;
  h+=_BBH+5;
  w=strlen(_locale[102])+2;
  x=6+2;
  if(x>w) w=x;
  w*=_CharWidth;
  w+=20;
  tcode=def;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[98],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[102]);
    ty+=_NBH+5;
    if(tcode>-1) {
      sprintf(buf1,"%d",tcode);
    } else {
      strcpy(buf1,"");
    }
    codesg=_CreateStringGadget(gfxwin,10,ty-2,6*_CharWidth,_NBH+6,buf1,3,1,0,1,7,3);
    if(tcode>-1) {
      sprintf(buf1,"%c",tcode);
    } else {
      strcpy(buf1," ");
    }
    text=_CreateText(gfxwin,10+6*_CharWidth+10,ty+_GlobalGUI.font->ascent,1,buf1);
    ty+=_NBH+6+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              returncode=tcode;
            } else if(tbutton->data==2) {
              returncode=-1;
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==KeyRelease) {
          if((msg->key<256)&&(msg->key>=0)) {
            x=msg->key;
            sprintf(codesg->string,"%d",x);
            if(codesg->startpos>=strlen(codesg->string)) codesg->startpos=0;
            if(codesg->cursor>=strlen(codesg->string)) codesg->cursor=0;
            sprintf(text->text,"%c",x);
            _RedrawWin(gfxwin);
            tcode=x;            
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==STRING_GADGET) {
            x=atoi(codesg->string);
            if(x<0) x=0;
            if(x>255) x=255;
            sprintf(codesg->string,"%d",x);
            if(codesg->startpos>=strlen(codesg->string)) codesg->startpos=0;
            if(codesg->cursor>=strlen(codesg->string)) codesg->cursor=0;
            sprintf(text->text,"%c",x);
            _RedrawWin(gfxwin);
            tcode=x;
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            returncode=-1;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return returncode;
}

void WCAutomaticCreation(int filedesc[])
{
  /* Fertig */
  int w,h,x,y,reads[3];
  unsigned char buf1[128],buffer[3][64],c1,c2,c3;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *report,*filesg[3];
  _SolidButton *fileexsb[3];
  FILE *fh[3];
  int okw,cw,ty;
  
  h=5;
  h+=3*(_NBH+6+5);
  h+=10;
  h+=_BBH+5;
  w=strlen(_locale[103])+4;
  w*=_CharWidth;
  w+=10+100+_BBH+10;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[101],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    for(x=0;x<3;x++) {
      sprintf(buf1,"%s %d:",_locale[103],x+1);
      _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,buf1);
      filesg[x]=_CreateStringGadget(gfxwin,10+(strlen(buf1)+1)*_CharWidth,ty-2,100,_NBH+6,"",1024,1,0,1,7,3+x*2);
      fileexsb[x]=_CreateSolidButton(gfxwin,10+(strlen(buf1)+1)*_CharWidth+100,ty-2,_BBH,_NBH+6,1,0,"");
      ty+=_NBH+6+5;
    }
    ty+=10;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              if((fileexsb[0]->bg==1)&&(fileexsb[1]->bg==1)&&(fileexsb[2]->bg==1)) {
                for(x=0;x<3;x++) {
                  fh[x]=fopen(filesg[x]->string,"r");
                }
                if((fh[0]!=NULL)&&(fh[1]!=NULL)&&(fh[2]!=NULL)) {
                  for(x=0,y=0;x<3;x++) {
                    reads[x]=fread(buffer[x],1,64,fh[x]);
                    if(reads[x]<reads[y]) y=x;
                  }
                  for(x=0;x<reads[y];x++) {
                    c1=buffer[0][x];
                    c2=buffer[1][x];
                    c3=buffer[2][x];
                    if((c1==c2)&&(c2==c3)&&(c1!=0)) {
                      filedesc[x]=c1;
                    } else {
                      filedesc[x]=-1;
                    }
                  }
                  for(x=reads[y];x<64;x++) {
                    filedesc[x]=-1;
                  }
                }
                for(x=0;x<3;x++) {
                  if(fh[x]!=NULL) fclose(fh[x]);
                }
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==STRING_GADGET) {
            report=(_StringGadget*)msg->gadget;
            x=report->data-3;
            x=x/2;
            fh[x]=fopen(report->string,"r");
            if(fh[x]==NULL) {
              fileexsb[x]->bg=0;
            } else {
              fclose(fh[x]);
              fileexsb[x]->bg=1;
            }
            _RedrawWin(gfxwin);
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
}

void WCEditFiledesc(int filedesc[])
{
  /* Fertig */
  int w,h,x,y;
  char buf1[1024],buf2[1024];
  int tfiledesc[64];
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _ListView *lv;
  _ListViewContent *templvc,*select=NULL,*report;
  int okw,cw,ty;

  h=5;
  h+=10*_BBH+5;
  h+=_BBH+5;
  h+=_BBH+5;
  h+=_BBH+5;
  for(x=0;x<64;x++) {
    tfiledesc[x]=filedesc[x];
  }
  w=strlen(_locale[97])+3+2+3+1+5;
  x=strlen(_locale[98])+strlen(_locale[99])+2+2+2;
  if(x>w) w=x;
  x=strlen(_locale[100])+2;
  if(x>w) w=x;
  w*=_CharWidth;
  w+=20;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[101],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    lv=_CreateListView(gfxwin,10,ty,w-20,10*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,3);
    templvc=NULL;
    for(x=0;x<64;x++) {
      sprintf(buf1,"%2d.",x);
      strcat(buf1,_locale[97]);
      if(tfiledesc[x]<0) {
        strcat(buf1,":      ");
      } else {
        sprintf(buf2,": %3d %c",tfiledesc[x],tfiledesc[x]);
        strcat(buf1,buf2);
      }
      templvc=_AddListViewContent(lv,templvc,buf1,7+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
    }
    ty+=10*_BBH+5;
    _CreateButton(gfxwin,10,ty,(strlen(_locale[98])+2)*_CharWidth,_BBH,_black,0,_locale[98],FALSE,_white,2,"",4);
    _CreateButton(gfxwin,w-10-(strlen(_locale[99])+2)*_CharWidth,ty,(strlen(_locale[99])+2)*_CharWidth,_BBH,_black,0,_locale[99],FALSE,_white,2,"",5);
    ty+=_BBH+5;
    _CreateButton(gfxwin,10,ty,w-20,_BBH,_black,0,_locale[100],FALSE,_white,2,"",6);
    ty+=_BBH+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);  
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              for(x=0;x<64;x++) {
                filedesc[x]=tfiledesc[x];
              }
            } else if(tbutton->data==2) {
            } else if(tbutton->data==4) {
              if(select!=NULL) {
                x=select->data-7;
                y=WCEditByte(tfiledesc[x]);
                if(y>-1) {
                  tfiledesc[x]=y;
                  sprintf(buf1,"%2d.",x);
                  strcat(buf1,_locale[97]);
                  sprintf(buf2,": %3d %c",tfiledesc[x],tfiledesc[x]);
                  strcat(buf1,buf2);
                  strcpy(select->text,buf1);
                  _RedrawWin(gfxwin);                    
                }
              }
            } else if(tbutton->data==5) {
              if(select!=NULL) {
                x=select->data-7;
                tfiledesc[x]=-1;
                sprintf(buf1,"%2d.",x);
                strcat(buf1,_locale[97]);
                strcat(buf1,":      ");
                strcpy(select->text,buf1);
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==6) {
              WCAutomaticCreation(tfiledesc);
              templvc=lv->first;
              for(x=0;x<64;x++) {
                sprintf(buf1,"%2d.",x);
                strcat(buf1,_locale[97]);
                if(tfiledesc[x]<0) {
                  strcat(buf1,":      ");
                } else {
                  sprintf(buf2,": %3d %c",tfiledesc[x],tfiledesc[x]);
                  strcat(buf1,buf2);
                }
                strcpy(templvc->text,buf1);
                templvc=templvc->next;
              }
              _RedrawWin(gfxwin);
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            report=msg->lv_oneselect;
            if(report!=NULL) {
              if(select!=NULL) {
                select->active=FALSE;
              }
              report->active=TRUE;
              select=report;
              _RedrawWin(gfxwin);
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;          
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
}

int WCEditType(struct _filetypedef *changeft)
{
  /* Fertig */
  char *tusercom,*textbuf,buf1[1024],buf2[1024];
  int w,h;
  long tcomnr,tflag1,tflag2;
  int returnvalue=0,windex[6],tfiledesc[64];
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *namesg,*infosg,*usercomsg,*patsg;
  _ChooseButton *usepatcb,*usefilecb;
  _ListView *comlv,*flaglv,*templv;
  _ListViewContent *templvc,*select=NULL,*report,*lvc;
  int x,y,e,okw,cw,ty;

  tcomnr=changeft->comnr;
  tflag1=changeft->flag1;
  tflag2=changeft->flag2;
  for(x=0;x<64;x++) {
    tfiledesc[x]=changeft->filedesc[x];
  }
  windex[0]=(strlen(_locale[89])+1+15)*_CharWidth;
  windex[1]=(strlen(_locale[90])+1+15)*_CharWidth;
  windex[2]=(strlen(_locale[63])+3+strlen(_locale[64]))*_CharWidth;
  windex[3]=(strlen(_locale[65])+1+15)*_CharWidth;
  windex[4]=(strlen(_locale[93])+1+15+4+strlen(_locale[94])+3)*_CharWidth;
  windex[5]=(strlen(_locale[95])+2+4+strlen(_locale[96])+3)*_CharWidth;
  for(x=1,y=0;x<6;x++) {
    if(windex[x]>windex[y]) y=x;
  }
  w=10+windex[y]+10;
  h=5;
  h+=_NBH+6+5;
  h+=_NBH+6+5;
  h+=_NBH;
  h+=5*_BBH+10;
  h+=_NBH+6+5;
  h+=_NBH+6+5;
  h+=_BBH+5;
  h+=_BBH+5;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[88],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[89]);
    namesg=_CreateStringGadget(gfxwin,20+strlen(_locale[89])*_CharWidth,ty-2,w-30-strlen(_locale[89])*_CharWidth,_NBH+6,changeft->name,MAX_FILETYPENAMELEN,1,0,1,7,3);
    ty+=_NBH+6+5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[90]);
    infosg=_CreateStringGadget(gfxwin,20+strlen(_locale[90])*_CharWidth,ty-2,w-30-strlen(_locale[90])*_CharWidth,_NBH+6,changeft->info,256,1,0,1,7,4);
    ty+=_NBH+6+5;
    _CreateText(gfxwin,20,ty+_GlobalGUI.font->ascent,1,_locale[63]);
    _CreateText(gfxwin,10+w/2,ty+_GlobalGUI.font->ascent,1,_locale[64]);
    ty+=_NBH;
    comlv=_CreateListView(gfxwin,10,ty,w/2-20,5*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,5);
    templvc=NULL;
    for(x=0;x<COMNR;x++) {
      templvc=_AddListViewContent(comlv,templvc,_localecoms[x],14+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
      if(tcomnr==x) {
        templvc->active=TRUE;
        select=templvc;
      } else {
        templvc->active=FALSE;
      }
    }
    flaglv=_CreateListView(gfxwin,w/2,ty,w/2-10,5*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,6);
    templvc=NULL;
    for(x=0;x<flaginfo[tcomnr][0];x++) {
      templvc=_AddListViewContent(flaglv,templvc,_localeflags[flaginfo[tcomnr][1]+x],14+COMNR+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=2;
      templvc->bg_select=1;
      y=pow(2,x);
      if((tflag1&y)==y) {
        templvc->select=TRUE;
      } else {
        templvc->select=FALSE;
      }
    }
    ty+=5*_BBH+10;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[65]);
    usercomsg=_CreateStringGadget(gfxwin,20+strlen(_locale[65])*_CharWidth,ty-2,w-30-strlen(_locale[65])*_CharWidth-20,_NBH+6,changeft->usercom,1024,1,0,1,7,7);
    _CreateButton(gfxwin,20+strlen(_locale[65])*_CharWidth+w-30-strlen(_locale[65])*_CharWidth-20,ty-2,_BBH,_NBH+6,_black,0,"",FALSE,_white,2,"",0);
    ty+=_NBH+6+5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[93]);
    patsg=_CreateStringGadget(gfxwin,20+strlen(_locale[93])*_CharWidth,ty-2,15*_CharWidth,_NBH+6,changeft->pattern,256,1,0,1,7,8);
    _CreateText(gfxwin,w-10-_BBH-(strlen(_locale[94])+1)*_CharWidth,ty+_GlobalGUI.font->ascent,1,_locale[94]);
    usepatcb=_CreateChooseButton(gfxwin,w-10-_BBH,ty,_BBH,_NBH+6,changeft->usepattern,9);
    ty+=_NBH+6+5;
    _CreateButton(gfxwin,10,ty,(strlen(_locale[95])+2)*_CharWidth,_BBH,_black,0,_locale[95],FALSE,_white,2,"",12);
    _CreateText(gfxwin,w-10-_BBH-(strlen(_locale[96])+1)*_CharWidth,ty+_GlobalGUI.font->ascent,1,_locale[96]);
    usefilecb=_CreateChooseButton(gfxwin,w-10-_BBH,ty,_BBH,_BBH,changeft->usefiledesc,11);
    ty+=_BBH+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              returnvalue=1;
              y=0;
              templvc=comlv->first;
              x=0;
              while(templvc!=NULL) {
                if(templvc->active==TRUE) y=x;
                templvc=templvc->next;
                x++;
              }
              changeft->comnr=y;
              templvc=flaglv->first;
              x=0;
              y=0;
              while(templvc!=NULL) {
                if(templvc->select==TRUE) {
                  y=y+pow(2,x);
                }
                templvc=templvc->next;
                x++;
              }
              changeft->flag1=y;
              textbuf=(char*)_allocsafe(strlen(namesg->string)+1);
              if(textbuf!=NULL) {
                strcpy(textbuf,namesg->string);
                _freesafe(changeft->name);
                changeft->name=textbuf;
              }
              tusercom=(char*)_allocsafe(strlen(usercomsg->string)+1);
              if(tusercom!=NULL) {
                strcpy(tusercom,usercomsg->string);
                _freesafe(changeft->usercom);
                changeft->usercom=tusercom;
              }
              textbuf=(char*)_allocsafe(strlen(infosg->string)+1);
              if(textbuf!=NULL) {
                strcpy(textbuf,infosg->string);
                _freesafe(changeft->info);
                changeft->info=textbuf;
              }
              textbuf=(char*)_allocsafe(strlen(patsg->string)+1);
              if(textbuf!=NULL) {
                strcpy(textbuf,patsg->string);
                _freesafe(changeft->pattern);
                changeft->pattern=textbuf;
              }
              changeft->usepattern=usepatcb->data;
              changeft->usefiledesc=usefilecb->data;
              for(x=0;x<64;x++) {
                changeft->filedesc[x]=tfiledesc[x];
              }
            } else if(tbutton->data==0) {
              x=WCChooseUFlag();
              if(x>=0) {
                strcpy(buf1,_UFlags[x]);
                if((strlen(usercomsg->string)+strlen(buf1))<1022) {
                  strncpy(buf2,usercomsg->string,usercomsg->cursor);
                  buf2[usercomsg->cursor]=0;
                  strcat(buf2,buf1);
                  strcat(buf2,(usercomsg->string)+usercomsg->cursor);
                  strcpy(usercomsg->string,buf2);
                  _RedrawWin(gfxwin);
                }
              }
            } else if(tbutton->data==2) {
            } else if(tbutton->data==12) {
              WCEditFiledesc(tfiledesc);
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            templv=msg->gadget;
            if(templv==comlv) {
              report=msg->lv_oneselect;
              if(report!=NULL) {
                if(select!=NULL) {
                  select->active=FALSE;
                }
                report->active=TRUE;
                select=report;
                x=report->data-14;
                lvc=flaglv->first;
                while(lvc!=NULL) {
                  _RemoveListViewContent(gfxwin,flaglv,lvc);
                  lvc=flaglv->first;
                }
                lvc=NULL;
                for(y=0;y<flaginfo[x][0];y++) {
                  lvc=_AddListViewContent(flaglv,lvc,_localeflags[flaginfo[x][1]+y],14+COMNR+y);
                  lvc->fg_normal=1;
                  lvc->bg_normal=0;
                  lvc->fg_select=2;
                  lvc->bg_select=1;
                  e=pow(2,y);
                  if((tflag1&e)==e) {
                    lvc->select=TRUE;
                  } else {
                    lvc->select=FALSE;
                  }
                }
                _RedrawWin(gfxwin);
              }
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return returnvalue;
}

void WCChangeTypes()
{
  /* Fertig */
  struct _filetypedef *tempft,*tempft1,*localfirst;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _ListView *lv;
  _ListViewContent *lvc1,*lvc2,*select,*report,*templvc;
  int w,h,x,y,z,tw,selitem,oldlen,newlen;
  char *text;
  int okw,cw,ty;

  localfirst=NULL;
  tempft=LConfig.firsttype;
  tempft1=NULL;
  while(tempft!=NULL) {
    if(tempft1==NULL) {
      tempft1=_DuplicateFiletype(tempft);
      localfirst=tempft1;
    } else {
      tempft1->next=_DuplicateFiletype(tempft);
      tempft1=tempft1->next;
    }
    tempft=tempft->next;
  }
  /* lokale Kopie erstellt */
  h=5;
  h+=6*_BBH+5;
  h+=_BBH+5;
  h+=_BBH+5;
  x=strlen(_locale[85])+strlen(_locale[86])+strlen(_locale[87])+strlen(_locale[88])+8;
  x*=_CharWidth;
  x+=10+10+10;
  y=strlen(_locale[11])+strlen(_locale[8]);
  y*=_CharWidth;
  y+=10;
  if(x>y) w=x; else w=y;
  w+=20;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[6],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    lv=_CreateListView(gfxwin,10,ty,w-20,6*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,7);
    select=NULL;
    selitem=-1;
    tempft=localfirst;
    templvc=NULL;
    x=0;
    while(tempft!=NULL) {
      templvc=_AddListViewContent(lv,templvc,tempft->name,8+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
      tempft=tempft->next;
      x++;
    }
    ty+=6*_BBH+5;
    tw=strlen(_locale[85])+2;
    tw*=_CharWidth;
    x=10;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[85],FALSE,_white,2,"",3);
    x+=10+tw;
    tw=strlen(_locale[86])+2;
    tw*=_CharWidth;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[86],FALSE,_white,2,"",4);
    x+=10+tw;
    tw=strlen(_locale[87])+2;
    tw*=_CharWidth;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[87],FALSE,_white,2,"",5);
    x+=10+tw;
    tw=strlen(_locale[88])+2;
    tw*=_CharWidth;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[88],FALSE,_white,2,"",6);
    ty+=_BBH+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              /* ok */
              tempft=LConfig.firsttype;
              LConfig.firsttype=localfirst;
            } else if(tbutton->data==2) {
              /* cancel */
              tempft=localfirst;
            } else if(tbutton->data==3) {
              /* new (fertig) */
              if(localfirst==NULL) {
                tempft=_CreateFiletype("???","",0,0,0,"","",FALSE,FALSE);
                localfirst=tempft;
              } else {
                tempft=localfirst;
                while(tempft->next!=NULL) {
                  tempft=tempft->next;
                }
                tempft->next=_CreateFiletype("???","",0,0,0,"","",FALSE,FALSE);
                tempft=tempft->next;
              }
              /* Edit tempft */
              WCEditType(tempft);
              lvc1=lv->first;
              if(lvc1==NULL) {
                templvc=_AddListViewContent(lv,lvc1,tempft->name,8);
                templvc->fg_normal=1;
                templvc->bg_normal=0;
                templvc->fg_select=1;
                templvc->bg_select=0;
                templvc->fg_active=2;
                templvc->bg_active=1;
                templvc->fg_sel_act=2;
                templvc->bg_sel_act=1;
              } else {
                x=0;
                while(lvc1->next!=NULL) {
                  lvc1=lvc1->next;
                  x++;
                }
                templvc=_AddListViewContent(lv,lvc1,tempft->name,8+1+x);
                templvc->fg_normal=1;
                templvc->bg_normal=0;
                templvc->fg_select=1;
                templvc->bg_select=0;
                templvc->fg_active=2;
                templvc->bg_active=1;
                templvc->fg_sel_act=2;
                templvc->bg_sel_act=1;
              }
              _RedrawWin(gfxwin);
            } else if(tbutton->data==4) {
              /* duplicate (fertig) */
              if(selitem>=0) {
                tempft1=localfirst;
                for(x=0;x<selitem;x++) {
                  tempft1=tempft1->next;
                }
                /* duplicate tempft1 */
                tempft=localfirst;
                while(tempft->next!=NULL) {
                  tempft=tempft->next;
                }
                tempft->next=_DuplicateFiletype(tempft1);
                tempft=tempft->next;
                lvc1=lv->first;
                if(lvc1==NULL) {
                  templvc=_AddListViewContent(lv,lvc1,tempft->name,8);
                  templvc->fg_normal=1;
                  templvc->bg_normal=0;
                  templvc->fg_select=1;
                  templvc->bg_select=0;
                  templvc->fg_active=2;
                  templvc->bg_active=1;
                  templvc->fg_sel_act=2;
                  templvc->bg_sel_act=1;
                } else {
                  x=0;
                  while(lvc1->next!=NULL) {
                    lvc1=lvc1->next;
                    x++;
                  }
                  templvc=_AddListViewContent(lv,lvc1,tempft->name,8+1+x);
                  templvc->fg_normal=1;
                  templvc->bg_normal=0;
                  templvc->fg_select=1;
                  templvc->bg_select=0;
                  templvc->fg_active=2;
                  templvc->bg_active=1;
                  templvc->fg_sel_act=2;
                  templvc->bg_sel_act=1;
                }
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==5) {
              /* del (fertig) */
              if(selitem>=0) {
                tempft1=NULL;
                tempft=localfirst;
                lvc1=lv->first;
                for(x=0;x<selitem;x++) {
                  tempft1=tempft;
                  tempft=tempft->next;
                  lvc1=lvc1->next;
                }
                /* del tempft */
                lvc2=lvc1->next;
                if(tempft1==NULL) {
                  localfirst=tempft->next;
                } else {
                  tempft1->next=tempft->next;
                }
                _FreeFiletype(tempft);
                _RemoveListViewContent(gfxwin,lv,lvc1);
                while(lvc2!=NULL) {
                  lvc2->data--;
                  lvc2=lvc2->next;
                }
                selitem=-1;
                select=NULL;
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==6) {
              /* edit */
              if(selitem>=0) {
                tempft=localfirst;
                for(x=0;x<selitem;x++) {
                  tempft=tempft->next;
                }
                /* Edit tempft */
                if(WCEditType(tempft)!=0) {
                  /* entsprechenden Eintrag (select) nderen */
                  oldlen=strlen(select->text);
                  newlen=strlen(tempft->name);
                  text=(char*)_allocsafe(newlen+1);
                  if(text!=NULL) {
                    strcpy(text,tempft->name);
                    _freesafe(select->text);
                    select->text=text;
                    if(newlen>lv->maxlength) {
                      lv->maxlength=newlen;
                    } else {
                      if(newlen<oldlen) {
                        templvc=lv->first;
                        for(x=0,y=0;x<lv->maxlines;x++) {
                          z=strlen(templvc->text);
                          if(z>y) y=z;
                          templvc=templvc->next;
                        }
                        lv->maxlength=y;
                        if(lv->hbar_startpos>=y) {
                          if(y>0) {
                            lv->hbar_startpos=y-1;
                          } else {
                            lv->hbar_startpos=0;
                          }
                        }
                      }
                    }
                    _RedrawWin(gfxwin);
                  }
                }
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              while(tempft!=NULL) {
                tempft1=tempft->next;
                _FreeFiletype(tempft);
                tempft=tempft1;
              }
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            report=msg->lv_oneselect;
            if(report!=NULL) {
              if(select!=NULL) {
                select->active=FALSE;
              }
              report->active=TRUE;
              select=report;
              selitem=report->data-8;
              _RedrawWin(gfxwin);
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            /* cancel */
            tempft=localfirst;
            _ReplyMessage(msg);
            while(tempft!=NULL) {
              tempft1=tempft->next;
              _FreeFiletype(tempft);
              tempft=tempft1;
            }
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return;  
}

int WCEditHotkey(struct _hotkeydef *changehk)
{
  char *tname,*tusercom,buf1[64],buf2[1024],*textbuf;
  int tmods,w,h;
  unsigned long tshortkey;
  long tcomnr,tflag1,tflag2;
  unsigned long newshortkey;
  int mods,returnvalue=0;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *title,*usercomsg;
  _Text *shortkeyt;
  _ListView *comlv,*flaglv,*templv;
  _ListViewContent *templvc,*select=NULL,*report,*lvc;
  int x,y,e;
  int okw,cw,ty;

  tshortkey=changehk->shortkey;
  tmods=KEYSTATEMASK(changehk->mods);
  tcomnr=changehk->comnr;
  tflag1=changehk->flag1;
  tflag2=changehk->flag2;
  x=strlen(_locale[60]);
  if(strlen(_locale[65])>x) x=strlen(_locale[65]);
  w=300+x*_CharWidth;
  h=5;
  h+=_NBH+6+5;
  h+=_NBH+5;
  h+=_NBH;
  h+=5*_BBH+10;
  h+=_NBH+6+5;
  h+=_BBH+5;
  textbuf=(char*)_allocsafe(1024);
  if(textbuf==NULL) return returnvalue;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[157],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[92]);
    title=_CreateStringGadget(gfxwin,20+strlen(_locale[92])*_CharWidth,ty-2,w-30-strlen(_locale[92])*_CharWidth,_NBH+6,changehk->name,256,1,0,1,7,3);
    ty+=_NBH+6+5;
    x=strlen(_locale[61]);
    if(strlen(_locale[62])>x) x=strlen(_locale[62]);
    _CreateButton(gfxwin,10,ty,(x+3)*_CharWidth,_NBH,_black,0,_locale[61],TRUE,_black,0,_locale[62],6);
    if(tshortkey==0) {
      strcpy(buf2,"");
    } else {
      strcpy(buf1,XKeysymToString(tshortkey));
      strcpy(buf2,"");
      if((tmods&Mod1Mask)==Mod1Mask) strcat(buf2,"Left Alt + ");
      if((tmods&ControlMask)==ControlMask) strcat(buf2,"Control + ");
      if((tmods&ShiftMask)==ShiftMask) strcat(buf2,"Shift + ");
      strcat(buf2,buf1);
    }
    shortkeyt=_CreateText(gfxwin,20+(x+3)*_CharWidth,ty+_GlobalGUI.font->ascent,1,"");
    _freesafe(shortkeyt->text);
    shortkeyt->text=textbuf;
    strcpy(shortkeyt->text,buf2);
    ty+=_NBH+5;
    _CreateText(gfxwin,20,ty+_GlobalGUI.font->ascent,1,_locale[63]);
    _CreateText(gfxwin,10+w/2,ty+_GlobalGUI.font->ascent,1,_locale[64]);
    ty+=_NBH;
    comlv=_CreateListView(gfxwin,10,ty,w/2-20,5*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,7);
    templvc=NULL;
    for(x=0;x<COMNR;x++) {
      templvc=_AddListViewContent(comlv,templvc,_localecoms[x],10+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
      if(tcomnr==x) {
        templvc->active=TRUE;
        select=templvc;
      } else {
        templvc->active=FALSE;
      }
    }
    flaglv=_CreateListView(gfxwin,w/2,ty,w/2-20,5*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,8);
    templvc=NULL;
    for(x=0;x<flaginfo[tcomnr][0];x++) {
      templvc=_AddListViewContent(flaglv,templvc,_localeflags[flaginfo[tcomnr][1]+x],10+COMNR+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=2;
      templvc->bg_select=1;
      y=pow(2,x);
      if((tflag1&y)==y) {
        templvc->select=TRUE;
      } else {
        templvc->select=FALSE;
      }
    }
    ty+=5*_BBH+10;
    _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[65]);
    usercomsg=_CreateStringGadget(gfxwin,20+strlen(_locale[65])*_CharWidth,ty-2,w-30-strlen(_locale[65])*_CharWidth-_BBH,_NBH+6,changehk->usercom,1024,1,0,1,7,9);
    _CreateButton(gfxwin,20+strlen(_locale[65])*_CharWidth+w-30-strlen(_locale[65])*_CharWidth-_BBH,ty-2,_BBH,_NBH+6,_black,0,"",FALSE,_white,2,"",0);
    ty+=_NBH+6+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              returnvalue=1;
              changehk->shortkey=tshortkey;
              changehk->mods=tmods;
              y=0;
              templvc=comlv->first;
              x=0;
              while(templvc!=NULL) {
                if(templvc->active==TRUE) y=x;
                templvc=templvc->next;
                x++;
              }
              changehk->comnr=y;
              templvc=flaglv->first;
              x=0;
              y=0;
              while(templvc!=NULL) {
                if(templvc->select==TRUE) {
                  y=y+pow(2,x);
                }
                templvc=templvc->next;
                x++;
              }
              changehk->flag1=y;
              tname=(char*)_allocsafe(strlen(title->string)+1);
              if(tname!=NULL) {
                strcpy(tname,title->string);
                _freesafe(changehk->name);
                changehk->name=tname;
              }
              tusercom=(char*)_allocsafe(strlen(usercomsg->string)+1);
              if(tusercom!=NULL) {
                strcpy(tusercom,usercomsg->string);
                _freesafe(changehk->usercom);
                changehk->usercom=tusercom;
              }
            } else if(tbutton->data==0) {
              x=WCChooseUFlag();
              if(x>=0) {
                strcpy(buf1,_UFlags[x]);
                if((strlen(usercomsg->string)+strlen(buf1))<1022) {
                  strncpy(buf2,usercomsg->string,usercomsg->cursor);
                  buf2[usercomsg->cursor]=0;
                  strcat(buf2,buf1);
                  strcat(buf2,(usercomsg->string)+usercomsg->cursor);
                  strcpy(usercomsg->string,buf2);
                  _RedrawWin(gfxwin);
                }
              }
            } else if(tbutton->data==6) {
              if(msg->button==Button1) {
                WCChooseShortkey(&newshortkey,&mods);
                if(newshortkey!=0) {
                  tshortkey=newshortkey;
                  tmods=mods;
                  strcpy(buf2,"");
                  if((tmods&Mod1Mask)==Mod1Mask) strcat(buf2,"Left Alt + ");
                  if((tmods&ControlMask)==ControlMask) strcat(buf2,"Control + ");
                  if((tmods&ShiftMask)==ShiftMask) strcat(buf2,"Shift + ");
                  strcat(buf2,XKeysymToString(tshortkey));
                  strcpy(shortkeyt->text,buf2);
                  _RedrawWin(gfxwin);
                }
              } else if(msg->button==Button3) {
                strcpy(shortkeyt->text,"");
                tshortkey=0;
                tmods=0;
                _RedrawWin(gfxwin);
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            templv=msg->gadget;
            if(templv==comlv) {
              report=msg->lv_oneselect;
              if(report!=NULL) {
                if(select!=NULL) {
                  select->active=FALSE;
                }
                report->active=TRUE;
                select=report;
                x=report->data-10;
                lvc=flaglv->first;
                while(lvc!=NULL) {
                  _RemoveListViewContent(gfxwin,flaglv,lvc);
                  lvc=flaglv->first;
                }
                lvc=NULL;
                for(y=0;y<flaginfo[x][0];y++) {
                  lvc=_AddListViewContent(flaglv,lvc,_localeflags[flaginfo[x][1]+y],10+COMNR+y);
                  lvc->fg_normal=1;
                  lvc->bg_normal=0;
                  lvc->fg_select=2;
                  lvc->bg_select=1;
                  e=pow(2,y);
                  if((tflag1&e)==e) {
                    lvc->select=TRUE;
                  } else {
                    lvc->select=FALSE;
                  }
                }
                _RedrawWin(gfxwin);
              }
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return returnvalue;
}

void WCChangeHotkeys()
{
  struct _hotkeydef *temphk,*temphk1,*localfirst;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _ListView *lv;
  _ListViewContent *lvc1,*lvc2,*select,*report,*templvc;
  int w,h,x,y,z,tw,selitem,oldlen,newlen;
  char *text;
  int okw,cw,ty;

  localfirst=NULL;
  temphk=LConfig.firsthotkey;
  temphk1=NULL;
  while(temphk!=NULL) {
    if(temphk1==NULL) {
      temphk1=_DuplicateHotkey(temphk);
      localfirst=temphk1;
    } else {
      temphk1->next=_DuplicateHotkey(temphk);
      temphk1=temphk1->next;
    }
    temphk=temphk->next;
  }
  /* lokale Kopie erstellt */
  h=5;
  h+=6*_BBH+5;
  h+=_BBH+5;
  h+=_BBH+5;
  x=strlen(_locale[154])+strlen(_locale[155])+strlen(_locale[156])+strlen(_locale[157])+8;
  x*=_CharWidth;
  x+=10+10+10;
  y=strlen(_locale[11])+strlen(_locale[8]);
  y*=_CharWidth;
  y+=10;
  if(x>y) w=x; else w=y;
  w+=20;
  okw=TextWidth(_locale[11],strlen(_locale[11]))+10;
  cw=TextWidth(_locale[8],strlen(_locale[8]))+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[91],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    ty=5;
    lv=_CreateListView(gfxwin,10,ty,w-20,6*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,7);
    select=NULL;
    selitem=-1;
    temphk=localfirst;
    templvc=NULL;
    x=0;
    while(temphk!=NULL) {
      templvc=_AddListViewContent(lv,templvc,temphk->name,8+x);
      templvc->fg_normal=1;
      templvc->bg_normal=0;
      templvc->fg_select=1;
      templvc->bg_select=0;
      templvc->fg_active=2;
      templvc->bg_active=1;
      templvc->fg_sel_act=2;
      templvc->bg_sel_act=1;
      temphk=temphk->next;
      x++;
    }
    ty+=6*_BBH+5;
    tw=strlen(_locale[154])+2;
    tw*=_CharWidth;
    x=10;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[154],FALSE,_white,2,"",3);
    x+=10+tw;
    tw=strlen(_locale[155])+2;
    tw*=_CharWidth;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[155],FALSE,_white,2,"",4);
    x+=10+tw;
    tw=strlen(_locale[156])+2;
    tw*=_CharWidth;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[156],FALSE,_white,2,"",5);
    x+=10+tw;
    tw=strlen(_locale[157])+2;
    tw*=_CharWidth;
    _CreateButton(gfxwin,x,ty,tw,_BBH,_black,0,_locale[157],FALSE,_white,2,"",6);
    ty+=_BBH+5;
    _CreateButton(gfxwin,10,ty,okw,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-cw,ty,cw,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) {
              /* ok */
              temphk=LConfig.firsthotkey;
              LConfig.firsthotkey=localfirst;
            } else if(tbutton->data==2) {
              /* cancel */
              temphk=localfirst;
            } else if(tbutton->data==3) {
              /* new (fertig) */
              if(localfirst==NULL) {
                temphk=_CreateHotkey("???",0,0,0,0,0,"");
                localfirst=temphk;
              } else {
                temphk=localfirst;
                while(temphk->next!=NULL) {
                  temphk=temphk->next;
                }
                temphk->next=_CreateHotkey("???",0,0,0,0,0,"");
                temphk=temphk->next;
              }
              /* Edit temphk */
              WCEditHotkey(temphk);
              lvc1=lv->first;
              if(lvc1==NULL) {
                templvc=_AddListViewContent(lv,lvc1,temphk->name,8);
                templvc->fg_normal=1;
                templvc->bg_normal=0;
                templvc->fg_select=1;
                templvc->bg_select=0;
                templvc->fg_active=2;
                templvc->bg_active=1;
                templvc->fg_sel_act=2;
                templvc->bg_sel_act=1;
              } else {
                x=0;
                while(lvc1->next!=NULL) {
                  lvc1=lvc1->next;
                  x++;
                }
                templvc=_AddListViewContent(lv,lvc1,temphk->name,8+1+x);
                templvc->fg_normal=1;
                templvc->bg_normal=0;
                templvc->fg_select=1;
                templvc->bg_select=0;
                templvc->fg_active=2;
                templvc->bg_active=1;
                templvc->fg_sel_act=2;
                templvc->bg_sel_act=1;
              }
              _RedrawWin(gfxwin);
            } else if(tbutton->data==4) {
              /* duplicate (fertig) */
              if(selitem>=0) {
                temphk1=localfirst;
                for(x=0;x<selitem;x++) {
                  temphk1=temphk1->next;
                }
                /* duplicate temphk1 */
                temphk=localfirst;
                while(temphk->next!=NULL) {
                  temphk=temphk->next;
                }
                temphk->next=_DuplicateHotkey(temphk1);
                temphk=temphk->next;
                lvc1=lv->first;
                if(lvc1==NULL) {
                  templvc=_AddListViewContent(lv,lvc1,temphk->name,8);
                  templvc->fg_normal=1;
                  templvc->bg_normal=0;
                  templvc->fg_select=1;
                  templvc->bg_select=0;
                  templvc->fg_active=2;
                  templvc->bg_active=1;
                  templvc->fg_sel_act=2;
                  templvc->bg_sel_act=1;
                } else {
                  x=0;
                  while(lvc1->next!=NULL) {
                    lvc1=lvc1->next;
                    x++;
                  }
                  templvc=_AddListViewContent(lv,lvc1,temphk->name,8+1+x);
                  templvc->fg_normal=1;
                  templvc->bg_normal=0;
                  templvc->fg_select=1;
                  templvc->bg_select=0;
                  templvc->fg_active=2;
                  templvc->bg_active=1;
                  templvc->fg_sel_act=2;
                  templvc->bg_sel_act=1;
                }
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==5) {
              /* del (fertig) */
              if(selitem>=0) {
                temphk1=NULL;
                temphk=localfirst;
                lvc1=lv->first;
                for(x=0;x<selitem;x++) {
                  temphk1=temphk;
                  temphk=temphk->next;
                  lvc1=lvc1->next;
                }
                /* del temphk */
                lvc2=lvc1->next;
                if(temphk1==NULL) {
                  localfirst=temphk->next;
                } else {
                  temphk1->next=temphk->next;
                }
                _FreeHotkey(temphk);
                _RemoveListViewContent(gfxwin,lv,lvc1);
                while(lvc2!=NULL) {
                  lvc2->data--;
                  lvc2=lvc2->next;
                }
                selitem=-1;
                select=NULL;
                _RedrawWin(gfxwin);
              }
            } else if(tbutton->data==6) {
              /* edit */
              if(selitem>=0) {
                temphk=localfirst;
                for(x=0;x<selitem;x++) {
                  temphk=temphk->next;
                }
                /* Edit temphk */
                if(WCEditHotkey(temphk)!=0) {
                  /* entsprechenden Eintrag (select) nderen */
                  oldlen=strlen(select->text);
                  newlen=strlen(temphk->name);
                  text=(char*)_allocsafe(newlen+1);
                  if(text!=NULL) {
                    strcpy(text,temphk->name);
                    _freesafe(select->text);
                    select->text=text;
                    if(newlen>lv->maxlength) {
                      lv->maxlength=newlen;
                    } else {
                      if(newlen<oldlen) {
                        templvc=lv->first;
                        for(x=0,y=0;x<lv->maxlines;x++) {
                          z=strlen(templvc->text);
                          if(z>y) y=z;
                          templvc=templvc->next;
                        }
                        lv->maxlength=y;
                        if(lv->hbar_startpos>=y) {
                          if(y>0) {
                            lv->hbar_startpos=y-1;
                          } else {
                            lv->hbar_startpos=0;
                          }
                        }
                      }
                    }
                    _RedrawWin(gfxwin);
                  }
                }
              }
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              while(temphk!=NULL) {
                temphk1=temphk->next;
                _FreeHotkey(temphk);
                temphk=temphk1;
              }
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==LISTVIEW_GADGET) {
            report=msg->lv_oneselect;
            if(report!=NULL) {
              if(select!=NULL) {
                select->active=FALSE;
              }
              report->active=TRUE;
              select=report;
              selitem=report->data-8;
              _RedrawWin(gfxwin);
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            /* cancel */
            temphk=localfirst;
            _ReplyMessage(msg);
            while(temphk!=NULL) {
              temphk1=temphk->next;
              _FreeHotkey(temphk);
              temphk=temphk1;
            }
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return;  
}

void WCSaveSettings(void)
{
  struct _color *tcol1,*tcol2=NULL;
  int count;
  struct _buttondef *tempb;
  int x,y,z;
  struct _pathdef *tempp;
  char *configfile;
  unsigned long size1;
  struct _filetypedef *tempft;
  struct _hotkeydef *temphk;
  FILE *fp;
  /* Farben anpassen */
  tcol1=LConfig.first;
  count=0;
  do {
    count++;
    if(count<=LConfig.colors) tcol2=tcol1;
    tcol1=tcol1->next;
  } while(tcol1!=NULL);
  if(count<LConfig.colors) {
    while(count!=LConfig.colors) {
      tcol2->next=_CreateCColor(0,0,0);
      tcol2=tcol2->next;
      if(tcol2==NULL) {printf("No Memory!!!\n");break;}
      count++;
    }
  } else if(count>LConfig.colors) {
    tcol1=tcol2->next;
    tcol2->next=NULL;
    while(tcol1!=NULL) {
      tcol2=tcol1->next;
      _FreeCColor(tcol1);
      tcol1=tcol2;
    }
    count=LConfig.colors;
  }
  /* Buttons anpassen */
  z=LConfig.numxbuttons*LConfig.numybuttons*2;
  WCCleanUpButtons(z);
  /* Buttons angepat */
  /* Pfade anpassen */
  x=1;
  tempp=LConfig.firstpath;
  while(tempp->next!=NULL) {
    tempp=tempp->next;
    x++;
  }
  y=x%LConfig.numybuttons;
  if(y>0) {
    for(z=y;z<LConfig.numybuttons;z++) {
      if(_CreateConfigPath(0,"",0,0,0,0,"")!=0) return;
    }
  }
  /* Nun existieren vielfache von numybuttons Def. */
  WCCleanUpPath(LConfig.firstpath,LConfig.numybuttons);
  /* Die Liste enthlt nun nur soviele Bnke wie bentigt werden */
  /* Speichern */
  configfile=(char*)_allocsafe(strlen(home)+8);
  strcpy(configfile,home);
  strcat(configfile,"/config");
  fp=fopen(configfile,"w");
  if(fp==NULL) {
    printf("%s\n",_locale[104]);
  } else {
    _FPutString("FORM",fp);
    _FPutLong(0L,fp);
    _FPutString("WCFG",fp);
    _FPutString("GLBL",fp);
    _FPutLong(2+3*LConfig.colors,fp);
    _FPutInt(LConfig.colors,fp);
    tcol1=LConfig.first;
    while(tcol1!=NULL) {
      _FPutChar(tcol1->red,fp);
      _FPutChar(tcol1->green,fp);
      _FPutChar(tcol1->blue,fp);
      tcol1=tcol1->next;
    }
    _FPutString("LANG",fp);
    _FPutLong(strlen(LConfig.lang),fp);
    _FPutString(LConfig.lang,fp);
    _FPutString("COLD",fp);
    _FPutLong(44L,fp);
    _FPutInt(LConfig.statusbarfg,fp);
    _FPutInt(LConfig.statusbarbg,fp);
    _FPutInt(LConfig.sel_lvbfg,fp);
    _FPutInt(LConfig.sel_lvbbg,fp);
    _FPutInt(LConfig.unsel_lvbfg,fp);
    _FPutInt(LConfig.unsel_lvbbg,fp);
    _FPutInt(LConfig.sel_dirfg,fp);
    _FPutInt(LConfig.sel_dirbg,fp);
    _FPutInt(LConfig.unsel_dirfg,fp);
    _FPutInt(LConfig.unsel_dirbg,fp);
    _FPutInt(LConfig.sel_filefg,fp);
    _FPutInt(LConfig.sel_filebg,fp);
    _FPutInt(LConfig.unsel_filefg,fp);
    _FPutInt(LConfig.unsel_filebg,fp);
    _FPutInt(LConfig.clockbarfg,fp);
    _FPutInt(LConfig.clockbarbg,fp);
    _FPutInt(LConfig.requestfg,fp);
    _FPutInt(LConfig.requestbg,fp);
    _FPutInt(LConfig.sel_pathfg,fp);
    _FPutInt(LConfig.sel_pathbg,fp);
    _FPutInt(LConfig.unsel_pathfg,fp);
    _FPutInt(LConfig.unsel_pathbg,fp);
    _FPutString("LDEF",fp);
    _FPutLong(14L,fp);
    _FPutChar(LConfig.leftvbar_left,fp);
    _FPutChar(LConfig.lefthbar_top,fp);
    _FPutInt(LConfig.lefthbar_height,fp);
    _FPutInt(LConfig.leftvbar_width,fp);
    _FPutChar(LConfig.rightvbar_left,fp);
    _FPutChar(LConfig.righthbar_top,fp);
    _FPutInt(LConfig.righthbar_height,fp);
    _FPutInt(LConfig.rightvbar_width,fp);
    _FPutChar(LConfig.numxbuttons,fp);
    _FPutChar(LConfig.numybuttons,fp);
    _FPutString("DIRS",fp);
    _FPutLong(4+strlen(LConfig.ldir)+4+strlen(LConfig.rdir),fp);
    _FPutLong(strlen(LConfig.ldir),fp);
    _FPutString(LConfig.ldir,fp);
    _FPutLong(strlen(LConfig.rdir),fp);
    _FPutString(LConfig.rdir,fp);
    _FPutString("BUTD",fp);
    tempb=LConfig.firstbutton;
    size1=0;
    while(tempb!=NULL) {
      size1+=31;
      size1+=strlen(tempb->text);
      size1+=strlen(tempb->usercom);
      tempb=tempb->next;
    }
    _FPutLong(size1,fp);
    tempb=LConfig.firstbutton;
    while(tempb!=NULL) {
      _FPutChar(tempb->check,fp);
      _FPutLong(strlen(tempb->text),fp);
      _FPutString(tempb->text,fp);
      _FPutInt(tempb->fg,fp);
      _FPutInt(tempb->bg,fp);
      _FPutLong(tempb->shortkey,fp);
      _FPutInt(tempb->mods,fp);
      _FPutLong(tempb->comnr,fp);
      _FPutLong(tempb->flag1,fp);
      _FPutLong(tempb->flag2,fp);
      _FPutLong(strlen(tempb->usercom),fp);
      _FPutString(tempb->usercom,fp);
      tempb=tempb->next;
    }
    _FPutString("PATD",fp);
    tempp=LConfig.firstpath;
    size1=0;
    while(tempp!=NULL) {
      size1+=19;
      size1+=strlen(tempp->text);
      size1+=strlen(tempp->path);
      tempp=tempp->next;
    }
    _FPutLong(size1,fp);
    tempp=LConfig.firstpath;
    while(tempp!=NULL) {
      _FPutChar(tempp->check,fp);
      _FPutLong(strlen(tempp->text),fp);
      _FPutString(tempp->text,fp);
      _FPutInt(tempp->fg,fp);
      _FPutInt(tempp->bg,fp);
      _FPutLong(tempp->shortkey,fp);
      _FPutInt(tempp->mods,fp);
      _FPutLong(strlen(tempp->path),fp);
      _FPutString(tempp->path,fp);
      tempp=tempp->next;
    }
    _FPutString("FITY",fp);
    tempft=LConfig.firsttype;
    size1=0;
    while(tempft!=NULL) {
      size1+=158;
      size1+=strlen(tempft->name);
      size1+=strlen(tempft->info);
      size1+=strlen(tempft->usercom);
      size1+=strlen(tempft->pattern);
      tempft=tempft->next;
    }
    _FPutLong(size1,fp);
    tempft=LConfig.firsttype;
    while(tempft!=NULL) {
      _FPutLong(strlen(tempft->name),fp);
      _FPutString(tempft->name,fp);
      _FPutLong(strlen(tempft->info),fp);
      _FPutString(tempft->info,fp);
      _FPutLong(tempft->comnr,fp);
      _FPutLong(tempft->flag1,fp);
      _FPutLong(tempft->flag2,fp);
      _FPutLong(strlen(tempft->usercom),fp);
      _FPutString(tempft->usercom,fp);
      _FPutLong(strlen(tempft->pattern),fp);
      _FPutString(tempft->pattern,fp);
      for(x=0;x<64;x++) {
        _FPutInt(tempft->filedesc[x],fp);
      }
      _FPutChar(tempft->usepattern,fp);
      _FPutChar(tempft->usefiledesc,fp);
      tempft=tempft->next;
    }
    _FPutString("HOTS",fp);
    temphk=LConfig.firsthotkey;
    size1=0;
    while(temphk!=NULL) {
      size1+=26;
      size1+=strlen(temphk->name);
      size1+=strlen(temphk->usercom);
      temphk=temphk->next;
    }
    _FPutLong(size1,fp);
    temphk=LConfig.firsthotkey;
    while(temphk!=NULL) {
      _FPutLong(strlen(temphk->name),fp);
      _FPutString(temphk->name,fp);
      _FPutLong(temphk->shortkey,fp);
      _FPutInt(temphk->mods,fp);
      _FPutLong(temphk->comnr,fp);
      _FPutLong(temphk->flag1,fp);
      _FPutLong(temphk->flag2,fp);
      _FPutLong(strlen(temphk->usercom),fp);
      _FPutString(temphk->usercom,fp);
      temphk=temphk->next;
    }
    _FPutString("FONT",fp);
    _FPutLong(strlen(LConfig.font),fp);
    _FPutString(LConfig.font,fp);
    fclose(fp);
  }
  _freesafe(configfile);
}

void WCSelectFont()
{
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *fontsg;
  _Text *infotext;
  char *nfont,*tstr;
  int x,x2,height;
  bool fontok;
  XFontStruct *fontstr;
  
  x=strlen(_locale[210]);
  if(strlen(_locale[211])>x) x=strlen(_locale[211]);
  x+=2;
  x2=strlen(_locale[8])+strlen(_locale[11])+2+2+5;
  if(x2>x) x=x2;
  x*=_CharWidth;
  x+=10+10;
  height=_NBH+6+_NBH+_BBH+30;
  fontok=TRUE;
  gfxwin=_OpenWindow(NULL,0,0,x,height,x,x,x,height,height,height,0,_locale[209],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateButton(gfxwin,10,height-25,(strlen(_locale[11])+2)*_CharWidth,20,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,x-(strlen(_locale[8])+2)*_CharWidth-10,height-25,(strlen(_locale[8])+2)*_CharWidth,20,_black,0,_locale[8],FALSE,_white,2,"",2);
    _CreateText(gfxwin,10,15,1,_locale[210]);
    fontsg=_CreateStringGadget(gfxwin,20,15+5,x-30,_NBH+6,LConfig.font,256,1,0,1,7,3);
    infotext=_CreateText(gfxwin,10,15+5+20+5+_CharHeight,1,"");
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if((tbutton->data==1)&&(fontok==TRUE)) {
              nfont=(char*)_allocsafe(strlen(fontsg->string)+1);
              strcpy(nfont,fontsg->string);
              _freesafe(LConfig.font);
              LConfig.font=nfont;
            }
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==STRING_GADGET) {
            nfont=(char*)_allocsafe(strlen(fontsg->string)+1);
            strcpy(nfont,fontsg->string);
            fontstr=XLoadQueryFont(_GlobalGUI.Dsp,nfont);
            if(fontstr==NULL) {
              tstr=(char*)_allocsafe(strlen(_locale[211])+1);
              strcpy(tstr,_locale[211]);
              _freesafe(infotext->text);
              infotext->text=tstr;
              fontok=FALSE;
            } else {
              tstr=(char*)_allocsafe(1);
              tstr[0]=0;
              _freesafe(infotext->text);
              infotext->text=tstr;              
              fontok=TRUE;
              XFreeFont(_GlobalGUI.Dsp,fontstr);
            }
            _RedrawWin(gfxwin);
	    _freesafe(nfont);
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
}

void CopyActConfig()
{
  struct _color *tcol1,*tcol2,*tcol3;
  struct _buttondef *tempb,*tempb1;
  struct _pathdef *tempp,*tempp1;
  struct _filetypedef *tempft,*tempft1;
  struct _hotkeydef *temphk,*temphk1;
  
  LConfig.colors=_WConfig.colors;
  LConfig.statusbarfg=_WConfig.statusbarfg;
  LConfig.statusbarbg=_WConfig.statusbarbg;
  LConfig.sel_lvbfg=_WConfig.sel_lvbfg;
  LConfig.sel_lvbbg=_WConfig.sel_lvbbg;
  LConfig.unsel_lvbfg=_WConfig.unsel_lvbfg;
  LConfig.unsel_lvbbg=_WConfig.unsel_lvbbg;
  LConfig.sel_dirfg=_WConfig.sel_dirfg;
  LConfig.sel_dirbg=_WConfig.sel_dirbg;
  LConfig.unsel_dirfg=_WConfig.unsel_dirfg;
  LConfig.unsel_dirbg=_WConfig.unsel_dirbg;
  LConfig.sel_filefg=_WConfig.sel_filefg;
  LConfig.sel_filebg=_WConfig.sel_filebg;
  LConfig.unsel_filefg=_WConfig.unsel_filefg;
  LConfig.unsel_filebg=_WConfig.unsel_filebg;
  LConfig.clockbarfg=_WConfig.clockbarfg;
  LConfig.clockbarbg=_WConfig.clockbarbg;
  LConfig.requestfg=_WConfig.requestfg;
  LConfig.requestbg=_WConfig.requestbg;
  LConfig.sel_pathfg=_WConfig.sel_pathfg;
  LConfig.sel_pathbg=_WConfig.sel_pathbg;
  LConfig.unsel_pathfg=_WConfig.unsel_pathfg;
  LConfig.unsel_pathbg=_WConfig.unsel_pathbg;
  LConfig.lefthbar_top=_WConfig.lefthbar_top;
  LConfig.leftvbar_left=_WConfig.leftvbar_left;
  LConfig.lefthbar_height=_WConfig.lefthbar_height;
  LConfig.leftvbar_width=_WConfig.leftvbar_width;
  LConfig.righthbar_top=_WConfig.righthbar_top;
  LConfig.rightvbar_left=_WConfig.rightvbar_left;
  LConfig.righthbar_height=_WConfig.righthbar_height;
  LConfig.rightvbar_width=_WConfig.rightvbar_width;
  LConfig.numxbuttons=_WConfig.numxbuttons;
  LConfig.numybuttons=_WConfig.numybuttons;
  LConfig.ldir=dupstring(_WConfig.ldir);
  LConfig.rdir=dupstring(_WConfig.rdir);
  LConfig.lang=dupstring(_WConfig.lang);
  LConfig.font=dupstring(_WConfig.font);
  tcol1=_WConfig.first;
  LConfig.first=tcol2=NULL;
  while(tcol1!=NULL) {
    tcol3=_CreateCColor(tcol1->red,tcol1->green,tcol1->blue);
    if(tcol3==NULL) {printf("No Memory!!!\n");break;}
    if(tcol2==NULL) {
      LConfig.first=tcol3;
    } else {
      tcol2->next=tcol3;
    }
    tcol2=tcol3;
    tcol1=tcol1->next;
  }
  tempb=_WConfig.firstbutton;
  LConfig.firstbutton=_DuplicateConfigButton(tempb);
  if(LConfig.firstbutton==NULL) {
    printf("No Memory!!!\n");
    return;
  }
  tempb1=LConfig.firstbutton;
  tempb=tempb->next;
  while(tempb!=NULL) {
    tempb1->next=_DuplicateConfigButton(tempb);
    tempb1=tempb1->next;
    tempb=tempb->next;
  }
  tempp=_WConfig.firstpath;
  LConfig.firstpath=_DuplicateConfigPath(tempp);
  if(LConfig.firstpath==NULL) {
    printf("No Memory!!!\n");
    return;
  }
  tempp1=LConfig.firstpath;
  tempp=tempp->next;
  while(tempp!=NULL) {
    tempp1->next=_DuplicateConfigPath(tempp);
    tempp1->next->prev=tempp1;
    tempp1=tempp1->next;
    tempp=tempp->next;
  }
  LConfig.firsttype=NULL;
  tempft=_WConfig.firsttype;
  tempft1=NULL;
  while(tempft!=NULL) {
    if(tempft1==NULL) {
      tempft1=_DuplicateFiletype(tempft);
      LConfig.firsttype=tempft1;
    } else {
      tempft1->next=_DuplicateFiletype(tempft);
      tempft1=tempft1->next;
    }
    tempft=tempft->next;
  }
  LConfig.firsthotkey=NULL;
  temphk=_WConfig.firsthotkey;
  temphk1=NULL;
  while(temphk!=NULL) {
    if(temphk1==NULL) {
      temphk1=_DuplicateHotkey(temphk);
      LConfig.firsthotkey=temphk1;
    } else {
      temphk1->next=_DuplicateHotkey(temphk);
      temphk1=temphk1->next;
    }
    temphk=temphk->next;
  }
}

void FreeLConfig()
{
  struct _filetypedef *tempft,*tempft1;
  struct _color *tempc,*tempc1;
  struct _buttondef *tempb,*tempb1;
  struct _pathdef *tempp,*tempp1;
  struct _hotkeydef *temphk,*temphk1;

  _freesafe(LConfig.lang);
  _freesafe(LConfig.ldir);
  _freesafe(LConfig.rdir);
  _freesafe(LConfig.font);
  tempc=LConfig.first;
  while(tempc!=NULL) {
    tempc1=tempc->next;
    _freesafe(tempc);
    tempc=tempc1;
  }
  tempb=LConfig.firstbutton;
  while(tempb!=NULL) {
    tempb1=tempb->next;
    _freesafe(tempb->text);
    _freesafe(tempb->usercom);
    _freesafe(tempb);
    tempb=tempb1;
  }
  LConfig.firstbutton=NULL;
  tempp=LConfig.firstpath;
  while(tempp!=NULL) {
    tempp1=tempp->next;
    _freesafe(tempp->text);
    _freesafe(tempp->path);
    _freesafe(tempp);
    tempp=tempp1;
  }
  LConfig.firstpath=NULL;
  temphk=LConfig.firsthotkey;
  while(temphk!=NULL) {
    temphk1=temphk->next;
    _freesafe(temphk->name);
    _freesafe(temphk->usercom);
    _freesafe(temphk);
    temphk=temphk1;
  }
  LConfig.firsthotkey=NULL;
  tempft=LConfig.firsttype;
  while(tempft!=NULL) {
    tempft1=tempft->next;
    _FreeFiletype(tempft);
    tempft=tempft1;
  }
  LConfig.firsttype=NULL;
}

int ChangeWorkerConfig()
{
  int returnvalue; /* 0=Abbruch, 1=Ok */
  DIR *dir;
  _GfxWin *gfxwin=NULL;
  _Message *msg;
  _Button *tbutton;
  int w,h,tw,x;
  
  returnvalue=0;
  dir=opendir(home);
  if(dir==NULL) {
    if(errno==ENOENT) {
      if(mkdir(home,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH)!=0) {
        printf("Can't creating the directory %s!\n",home);
        return 0;
      }
    } else {
      printf("Error while opening the directory %s.\n",home);
      return 0;
    }
  } else closedir(dir);
  /* Aktuelle Konfiguration kopieren */
  CopyActConfig();
  /* Normale Oberflche starten */
  h=5+10*_BBH+11*3+10+2*_NBH;
  for(x=1,w=0;x<9;x++) {
    tw=TextWidth(_locale[x],strlen(_locale[x]));
    if(tw>w) w=tw;
  }
  tw=TextWidth(_locale[91],strlen(_locale[91]));
  if(tw>w) w=tw;
  tw=TextWidth(_locale[209],strlen(_locale[209]));
  if(tw>w) w=tw;
  tw=_CharWidth*20;
  if(tw>w) w=tw;
  tw=_CharWidth*26;
  if(tw>w) w=tw;
  w+=20;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[0],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateButton(gfxwin,10,5,w-20,_BBH,_black,0,_locale[1],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,10,5+3+_BBH,w-20,_BBH,_black,0,_locale[2],FALSE,_white,2,"",2);
    _CreateButton(gfxwin,10,5+2*3+2*_BBH,w-20,_BBH,_black,0,_locale[3],FALSE,_white,2,"",3);
    _CreateButton(gfxwin,10,5+3*3+3*_BBH,w-20,_BBH,_black,0,_locale[4],FALSE,_white,2,"",4);
    _CreateButton(gfxwin,10,5+4*3+4*_BBH,w-20,_BBH,_black,0,_locale[5],FALSE,_white,2,"",5);
    _CreateButton(gfxwin,10,5+5*3+5*_BBH,w-20,_BBH,_black,0,_locale[6],FALSE,_white,2,"",6);
    _CreateButton(gfxwin,10,5+6*3+6*_BBH,w-20,_BBH,_black,0,_locale[91],FALSE,_white,2,"",7);
    _CreateButton(gfxwin,10,5+10*3+8*_BBH,w-20,_BBH,_black,0,_locale[7],FALSE,_white,2,"",8);
    _CreateButton(gfxwin,10,5+11*3+9*_BBH,w-20,_BBH,_black,0,_locale[8],FALSE,_white,2,"",9);
    _CreateButton(gfxwin,10,5+7*3+7*_BBH,w-20,_BBH,_black,0,_locale[209],FALSE,_white,2,"",10);
    _CreateText(gfxwin,10,10+12*3+10*_BBH+_CharHeight-1,1,"Worker Configuration");
    _CreateText(gfxwin,10,10+12*3+10*_BBH+_NBH+_CharHeight-1,1,"Copyright by Ralf Hoffmann");
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            switch(tbutton->data) {
              case 1:WCChangeGLBL();
                     break;
              case 2:WCChangeCOLD();
                     break;
              case 3:WCChangeStartup();
                     break;
              case 4:WCChangeButtons();
                     break;
              case 5:WCChangePath();
                     break;
              case 6:WCChangeTypes();
                     break;
              case 7:WCChangeHotkeys();
                     break;
              case 8:WCSaveSettings();
	             returnvalue=1;
                     break;
              case 10:WCSelectFont();
                      break;
            }
            if((tbutton->data==8)||(tbutton->data==9)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
    FreeLConfig();
  }
  return returnvalue;
}

